// Car.h: interface for the Car class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CAR_H__8D57AA5E_D12A_4C55_816E_66F68580F88E__INCLUDED_)
#define AFX_CAR_H__8D57AA5E_D12A_4C55_816E_66F68580F88E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RoutingAlgo.h"

class Car  
{
public:
	bool m_bWriteToLog;//raz 17-07-06
	bool m_bFirst;
	int m_id;
	DWORD m_startTime;
	DWORD m_initialStartTime;
	CMapWordToPtr m_routeTable;
	CWordArray m_path;
	CWordArray m_pathWeight;//raz 27-07-06
	CWordArray m_weight;
	RoutingAlgo* m_pAlgo;
	bool m_bInQueue;
	int m_sourceNode;
	int m_origionSourceNode;
	int m_destinationNode;
	CString m_shortestPath;
	int m_pathTime;
	int m_type;
	int m_nodeNum;
	bool m_bTraffic;
	int m_dist;
	int tmpTime;
	bool m_bNotSpecial;

	bool m_bLiar; //raz 26-12-05
	bool m_bTrueReliableCar;//12-03-07
	bool m_bCalcRouteOnce; //raz 09-06-06

public:
	Create(int num,int source,int destination,int type,/*raz 26-12-05*/bool bIsLiarCar, bool bIsTrueReliableCar, /*raz 17-07-06*/bool bWriteToLog);
	CString Car::Save();
	void Load(CPtrArray* array);
	static Car* Load(CStdioFile* pFile);
	void UpdateNetwork(CPtrArray* pEdges);
	void UpdateEdge(int roadId,double weight);
	void UpdateNetwork();
	void UpdateNetwork(int road);
	CEdgesArray* GetEdges();
	CEdgesArray* GetRatedEdges();
	bool isPublicInfo();
	bool isRealPublicInfo();
	bool isGossiping();
	bool isLiar(); //raz 26-12-05
	bool isTrueReliable();//12-03-07
	bool isRegular();
	int GetPathTime();
	void UpdateGossipInfo(int road,Car* pCar);
	void UpdateJunctionGossipInfo(int junction,Car* pCar);
	void Init();
	CString GetShortestPath();
	void BeforeRoad(int road);
	void BeforeQueue();
	void UpdateTime();
	int GetRoute(int id);
	CString GetPath();
	CString GetPathWithWeights();
	CString GetWeights();
	void Calc();
	void Clear();
	void Clean();
	void ClearRoutingInfo();
	void UpdateCurrentEdge(int road);
	Car();
	Car(double** matrix,int num,int source,int destination,int type, /*raz 26-12-05*/bool bIsLiarCar, bool bIsTrueReliablecar, /*raz 17-07-06*/bool bWriteToLog);
	virtual ~Car();
	int GetOriginalDistance(); //raz 15-07-06
private:
	CString m_shortesPathWeight; //raz 15-07-06
};

#endif // !defined(AFX_CAR_H__8D57AA5E_D12A_4C55_816E_66F68580F88E__INCLUDED_)
