// CentralInfo.cpp: implementation of the CentralInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CentralInfo.h"
#include <conio.h>
#define _COUNT_ 50000

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

const int TOTAL_CARS_NUMBER = 40000;

bool CentralInfo::bIsPrintedCar[TOTAL_CARS_NUMBER];
bool CentralInfo::bIsPrintedCarSameIteration[TOTAL_CARS_NUMBER];
bool CentralInfo::print=false;

//raz 09-09-06
int CentralInfo::predefinedLiars[MAX_POSSIBLE_LIARS];
int CentralInfo::nextLiarId;
int CentralInfo::nextLiarIdIndex;

int CentralInfo::predefinedTrueReliableCars[MAX_POSSIBLE_TRUE_RELIABLE_CARS];
int CentralInfo::nextTrueReliableCarId;
int CentralInfo::nextTrueReliableCarIdIndex;

DWORD CentralInfo::g_simulationLength=500;//14-04-06, raz: was 100 (but in config file is 500)
CStdioFile CentralInfo::g_logFile;
DWORD CentralInfo::g_currentTime=0;
DWORD CentralInfo::g_currentStep=1;
bool CentralInfo::g_bSimulate=false;
int CentralInfo::g_carsPerStep=3;
int CentralInfo::g_carId = 0;
Simulation* CentralInfo::g_pSimulation=NULL;
int CentralInfo::g_simulationIterations=3;
int CentralInfo::g_currentSimulationIteration=0;
int CentralInfo::g_sleepInterval=500;
bool CentralInfo::g_toggleFlag=false;
int CentralInfo::g_simulationCount=0;
Statistics CentralInfo::statistics;
double CentralInfo::g_gossipPercent = 1;
double CentralInfo::g_gossipCarPercent = 0.5;
int CentralInfo::g_gossipQueueSize = 0;
int CentralInfo::g_gossipFactor = 100;
double CentralInfo::g_learningFactor = 1;
double CentralInfo::g_gossipLearningFactor = 0.5;
int CentralInfo::CarsPerLengthUnit = 10;

//TODO:(12) Decide whether to show the GUI or not (mainly in order to run the BatchSimulate immediately (without GUI))
//visual=false --> no GUI is shown
bool CentralInfo::g_showVisual = false;


int CentralInfo::g_bPublicInfo = 0;
int CentralInfo::g_calculatingPercent = 100;
int CentralInfo::g_queueSize = 30;
int CentralInfo::g_index = 0;
CString CentralInfo::g_saveCarInfoPath = "";
CString CentralInfo::g_carPath = "";
int CentralInfo::g_gossipLimitInfo = 100;
int CentralInfo::g_gossipEdgeRating = 0;
bool CentralInfo::g_bGossipUpdateProbability = true;//deciding whether to calculate the learning probability
bool CentralInfo::g_bLogFileOpen = false;
int CentralInfo::m_gossipCarsId[MAX_GOSSIP_CARS];
int CentralInfo::m_gossipCarIndex = 0;
bool CentralInfo::g_bPredefinedGossipCars = false;


//TODO:(1) Paths to be replaced - need to update the path every run (liarsX should be the same as g_liarCountPath)
CString CentralInfo::BASE_PATH ="";
char CentralInfo::FILE_OPEN_PATH[MAX_FILE_PATH_LEN] = "C:\\raz\\network.txt";
char CentralInfo::BATCH_OPEN_PATH[MAX_FILE_PATH_LEN] = "C:\\raz\\batchFile.txt";
CString CentralInfo::CARS_FILE_BASE_PATH = "C:\\"; //raz 29-12-05
CString CentralInfo::g_matrixDistFile = BASE_PATH + "MatrixDist.txt";
CString CentralInfo::LOG_PATH=BASE_PATH+"\\Logs\\";

//the following parameters are overridden in CVisualTransportationNetworkApp::InitInstance
//just before simulating the batch file
//the values are taken from the file generalParameters.txt
int CentralInfo::g_liarFactor = 20; //in percent - Need to update every run (raz)
int CentralInfo::g_liarsNumber = 0;//current number of liars in the system
CString CentralInfo::g_liarCountPath = "\\liars0"; //Need to update every run (raz)
int CentralInfo::g_trueReliableFactor = 1; //in percent - Need to update every run (raz)
int CentralInfo::g_trueReliableNumber = 0;//current number of true reliable cars in the system
int CentralInfo::g_iterationGeneralParam = -1;
int CentralInfo::g_sessionGeneralParam = -1;
int CentralInfo::g_liarsSameRoute = -1;
int CentralInfo::g_approvedNumberLiar = 10000;//raz 30-08-06, used in generalParameters
int CentralInfo::g_approvedNumberTrueReliable = 10000;//used in generalParameters
int CentralInfo::g_debugLevel=60;//the debug level of the run. 0 = everything is written to the log
int CentralInfo::g_liesIgnoreRule=0;//0 = ignoring self lies only, 1 = ignoring all lies
int CentralInfo::g_liesWhoIgnores=1;//0 = everyone ignores lies, 1 = only liars/predefined cars
int CentralInfo::g_runOutsideGui=1;//0 = run with GUI, 1 = run without GUI

// the following 2 parameters are overridden in CVisualTransportationNetworkView::Load
// The Statistics and Xcel are 2 directories inside each session and each liar path
CString CentralInfo::STATISTICS_PATH="C:\\Users\\raz\\Phd\\Gossip Chapter\\Cars20-liars\\";
CString CentralInfo::XCEL_PATH="C:\\Users\\raz\\Phd\\Gossip Chapter\\Cars20-liars\\";


//raz 24-04-06
WORD CentralInfo::TRUE_DATA = 0;
WORD CentralInfo::FALSE_DATA = 1;
WORD CentralInfo::UNKNOWN_DATA = 2;

int CentralInfo::temp = 0;

CentralInfo::CentralInfo()
{

}

void CentralInfo::Clear()
{
	g_simulationLength=500;
	g_currentTime=0;
	g_currentStep=1;
	g_bSimulate=false;
	g_carsPerStep=3;
	g_carId = 0;
	g_pSimulation=NULL;
	g_simulationIterations=3;
	g_currentSimulationIteration=0;
	//g_debugLevel=60;
	g_sleepInterval=500;
	g_toggleFlag=false;
	g_simulationCount=0;
	g_gossipPercent = 1;
	g_gossipCarPercent = 0.5;
	g_gossipFactor = 100;
	g_learningFactor = 1;
	g_gossipLearningFactor = 0.5;
	CarsPerLengthUnit = 10;
	g_bPublicInfo = 0;
	g_calculatingPercent = 100;
	g_queueSize = 30;
	g_saveCarInfoPath = "";
	g_gossipQueueSize = 0;
}

CentralInfo::~CentralInfo()
{

}


bool CentralInfo::SetToggle()
{
	if(g_toggleFlag)
		g_toggleFlag=false;
	else
		g_toggleFlag=true;
	return g_toggleFlag;
}

void  CentralInfo::writeLineToFile(int level,const char *format, ...)
{
	if(level>=g_debugLevel)
	{
		char tmpStr[_COUNT_];
		va_list arglist;
		va_start(arglist, format);
		vsprintf(tmpStr, format, arglist);
		va_end(arglist);
		CString str(tmpStr);
		g_logFile.WriteString(str+"\n");
		g_logFile.Flush();
	}
}
void  CentralInfo::writeToFile(int level,const char *format, ...)
{
	if(level>=g_debugLevel)
	{
		char tmpStr[_COUNT_];
		va_list arglist;
		va_start(arglist, format);
		vsprintf(tmpStr, format, arglist);
		va_end(arglist);
		CString str(tmpStr);
		g_logFile.WriteString(str);
		g_logFile.Flush();
	}
}

void CentralInfo::writeConfiguration(CStdioFile* pFile)
{
	char s[100];
	pFile->WriteString("<Configuration>");
	itoa(CentralInfo::g_simulationLength,s,10);
	pFile->WriteString(CString("\nSimulation Length: ")+s);
	itoa(CentralInfo::g_carsPerStep,s,10);
	pFile->WriteString(CString("\nCars per step: ")+s);
	itoa(CentralInfo::g_simulationIterations,s,10);
	pFile->WriteString(CString("\nSimulation iterations: ")+s);
	itoa(CentralInfo::g_sleepInterval,s,10);
	pFile->WriteString(CString("\nSleep interval: ")+s);
	itoa(CentralInfo::g_debugLevel,s,10);
	pFile->WriteString(CString("\nDebug level: ")+s);
	itoa(CentralInfo::g_gossipPercent*100,s,10);
	pFile->WriteString(CString("\nGossip percent: ")+s);
	itoa(CentralInfo::g_gossipCarPercent*100,s,10);
	pFile->WriteString(CString("\nGossip car percent: ")+s);
	itoa(CentralInfo::g_gossipQueueSize,s,10);
	pFile->WriteString(CString("\nGossip queue size: ")+s);
	itoa(CentralInfo::g_gossipLimitInfo,s,10);
	pFile->WriteString(CString("\nGossip Info perecnt: ")+s);
	itoa(CentralInfo::g_gossipEdgeRating,s,10);
	pFile->WriteString(CString("\nGossip edge rating: ")+s);
	itoa(CentralInfo::CarsPerLengthUnit,s,10);
	pFile->WriteString(CString("\nCarsPerLengthUnit: ")+s);
	itoa(CentralInfo::g_bPublicInfo,s,10);
	pFile->WriteString(CString("\nPublicInfo: ")+s);
	itoa(CentralInfo::g_calculatingPercent,s,10);
	pFile->WriteString(CString("\nCalculatingPercent: ")+s);
	itoa(CentralInfo::g_queueSize,s,10);
	pFile->WriteString(CString("\nQueueSize: ")+s);
//	itoa(CentralInfo::g_saveCarInfo,s,10);
	pFile->WriteString(CString("\nSaveCarInfo: ")+(LPCSTR)CentralInfo::g_saveCarInfoPath);
	pFile->WriteString("\n</Configuration>\n");
}

//14-04-06 raz
void CentralInfo::PrintConsole(CString msg)
{
	CTime CurTime = CTime::GetCurrentTime();
	int h = CurTime.GetHour();
	int m = CurTime.GetMinute();
	int s = CurTime.GetSecond();
	CString time;
	time.Format("%.2d:%.2d.%.2d", h, m, s);
	_cprintf("%s [%s]\n",msg, time);
}

void  CentralInfo::writeToFile(const char *format, ...)
{
/*	char tmpStr[_COUNT_];
	va_list arglist;
	va_start(arglist, format);
	vsprintf(tmpStr, format, arglist);
	va_end(arglist);
	CString str(tmpStr);
	g_logFile.WriteString(str);
	g_logFile.Flush();
*/
}

void  CentralInfo::writeLineToFile(const char *format, ...)
{
/*	char tmpStr[_COUNT_];
	va_list arglist;
	va_start(arglist, format);
	vsprintf(tmpStr, format, arglist);
	va_end(arglist);
	CString str(tmpStr);
	g_logFile.WriteString(str+"\n");
	g_logFile.Flush();
*/
}


void  CentralInfo::writeLineToString(CString& str,const char *format, ...)
{
	char tmpStr[_COUNT_];
	va_list arglist;
	va_start(arglist, format);
	vsprintf(tmpStr, format, arglist);
	va_end(arglist);
	CString s(tmpStr);
	str+=s;
}

void CentralInfo::calculateNextLiarId()
{
	nextLiarIdIndex++;
	if (nextLiarIdIndex < MAX_POSSIBLE_LIARS)
		nextLiarId = predefinedLiars[nextLiarIdIndex];
}

void CentralInfo::calculateNextTrueReliableCarId()
{
	nextTrueReliableCarIdIndex++;
	if (nextTrueReliableCarIdIndex < MAX_POSSIBLE_TRUE_RELIABLE_CARS)
		nextTrueReliableCarId = predefinedTrueReliableCars[nextTrueReliableCarIdIndex];
}

int CentralInfo::getNextLiarId()
{
	return nextLiarId;
}

int CentralInfo::getNextTrueReliableCarId()
{
	return nextTrueReliableCarId;
}


void CentralInfo::init()
{
	srand(time(NULL));


	//raz 08-09-06
	for (int i = 0; i < 100; ++i)
	{
		predefinedLiars[i] = -1;
		predefinedTrueReliableCars[i] = -1;
	}

	// load predefined liars from file
	CString line, param, value;
	CStdioFile paramsFile;
	if(paramsFile.Open(CentralInfo::BASE_PATH + "\\cars20-liars\\liarCars.txt",CFile::modeRead| CFile::shareDenyNone))
	{
		i = 0;
		while(paramsFile.ReadString(line) && line !="" && i < MAX_POSSIBLE_LIARS)
		{
			param = CentralInfo::GetToken(line,0,'=');
			value = CentralInfo::GetNextToken(line,'=',true);
			predefinedLiars[i++] = atoi(value);
		}
		nextLiarId = predefinedLiars[0];
		nextLiarIdIndex = 0;
	}

	//load predefined true reliable cars from file
	if(paramsFile.Open(CentralInfo::BASE_PATH + "\\cars20-liars\\trueReliableCars.txt",CFile::modeRead| CFile::shareDenyNone))
	{
		i = 0;
		while(paramsFile.ReadString(line) && line !="" && i < MAX_POSSIBLE_TRUE_RELIABLE_CARS)
		{
			param = CentralInfo::GetToken(line,0,'=');
			value = CentralInfo::GetNextToken(line,'=',true);
			predefinedTrueReliableCars[i++] = atoi(value);
		}
		nextTrueReliableCarId = predefinedTrueReliableCars[0];
		nextTrueReliableCarIdIndex = 0;
	}

	InitPrintedCars();
	print = false;
}

void CentralInfo::InitPrintedCars()
{
	for (int i = 0; i < TOTAL_CARS_NUMBER; ++i)
	{
		bIsPrintedCar[i] = false;
		bIsPrintedCarSameIteration[i] = false;
	}
}

void CentralInfo::openLog(CString file)
{
	::CreateDirectory(LOG_PATH, NULL);
	CString fileName = incrementFileName(LOG_PATH,file,"LogFile.txt");
	CentralInfo::PrintConsole(fileName);
	if (g_logFile.Open(fileName,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone))
		g_bLogFileOpen = true;
}

CString CentralInfo::incrementFileName(CString path,CString file,CString suffix)
{
	CString fileName = path+file+suffix;
	CFileStatus status;
	status.m_size=-1;
	CString strIndex;
	int index=0;
	CFile::GetStatus(fileName,status);
	while(CFile::GetStatus(fileName,status))
	{
		index++;
		strIndex.Format("_%d_",index);
		fileName = path+file+strIndex+suffix;
	}
	return fileName;

}
void CentralInfo::incrememtTime()
{
	g_currentTime += g_currentStep;

	InitPrintedCars();
	print = false;
}

int CentralInfo::getNextCarId()
{
	int id=g_carId;
	g_carId++;
	return id;
}

bool CentralInfo::IsGossipMode()
{
	if(CentralInfo::g_bPublicInfo==0 && CentralInfo::g_gossipCarPercent>0)
		return true;
	return false;
}

CString CentralInfo::GetToken(CString str, int startIndex, char delimiter)
{
	g_index = str.Find(delimiter,startIndex);
	return str.Mid(startIndex,g_index-startIndex);
}

CString CentralInfo::GetNextToken(CString str,char delimiter,bool finish)
{
	int startIndex = g_index+1;
	g_index = str.Find(delimiter,startIndex);
	if(g_index==-1)
	{
		if(finish)
			return str.Mid(startIndex,str.GetLength()-startIndex);
		else
			::AfxMessageBox("Error GetNextToken");
	}
	return str.Mid(startIndex,g_index-startIndex);
}

int CentralInfo::ReverseSlashFind(CString str)
{
	int index;
	if((index=str.ReverseFind('/'))!=-1)
		return index;
	if((index=str.ReverseFind('\\'))!=-1)
		return index;
	return -1;
}

void CentralInfo::addGossipCarId(int carId)
{
	m_gossipCarsId[m_gossipCarIndex] = carId;
	
	m_gossipCarIndex++;
}

bool CentralInfo::isCarGossip(int carId)
{
	bool bFound = false;
	bool bGossipCar = false;
	for (int i = 0; i < m_gossipCarIndex && !bFound; ++i)
	{
		if (m_gossipCarsId[i] == carId)
		{
			bGossipCar = true;
			bFound = true;
		}
		else if (m_gossipCarsId[i] > carId) // passed the option
		{
			bGossipCar = false;
			bFound = true;
		}
	}

	return bGossipCar;
}

void CentralInfo::initGossipCarsIds()
{
	for (int i = 0; i < MAX_GOSSIP_CARS; ++i)
		m_gossipCarsId[i] = -1;
}


bool CentralInfo::IsPrintedInIteration(int carId)
{
	return bIsPrintedCar[carId];
}

void CentralInfo::SetPrintedInIteration(int carId, bool value)
{
	bIsPrintedCar[carId] = value;
}

bool CentralInfo::IsPrintedInSameIteration(int carId)
{
	return bIsPrintedCarSameIteration[carId];
}

void CentralInfo::SetPrintedInSameIteration(int carId, bool value)
{
	bIsPrintedCarSameIteration[carId] = value;
}