// CentralInfo.h: interface for the CentralInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CENTRALINFO_H__CB04B43C_CE30_4EE3_98BF_661ED561C991__INCLUDED_)
#define AFX_CENTRALINFO_H__CB04B43C_CE30_4EE3_98BF_661ED561C991__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Simulation;
#include "Statistics.h"


const WORD IMPORTANT_MESSAGE_LEVEL = 100;
const WORD DEBUG_MESSAGE_LEVEL = 10;
const WORD MAX_GOSSIP_CARS = 9000;
const WORD MAX_FILE_PATH_LEN = 1000;
const WORD MAX_POSSIBLE_LIARS = 100;
const WORD MAX_POSSIBLE_TRUE_RELIABLE_CARS = 4000;
const WORD HISTORY_SIZE = 3;
const WORD TIME_THRESHOLD = 20;
const WORD WEIGHT_THRESHOLD = 10;


class CentralInfo  
{
public:
	static bool print;
	static bool bIsPrintedCar[];
	static bool bIsPrintedCarSameIteration[];

	static int g_liesIgnoreRule;
	static int g_liesWhoIgnores;

	static int g_iterationGeneralParam;
	static int g_sessionGeneralParam;
	static int g_liarsSameRoute;
	static int g_runOutsideGui;

	static bool g_bPredefinedGossipCars;
	static int temp;//@@
	static WORD TRUE_DATA; //raz 24-04-06
	static WORD FALSE_DATA; //raz 24-04-06
	static WORD UNKNOWN_DATA; //raz 24-04-06
	static DWORD g_simulationLength;
	static DWORD g_currentTime;
	static DWORD g_currentStep;
	static bool g_bSimulate;
	static int g_carsPerStep;
	static CStdioFile g_logFile;
	static bool g_bLogFileOpen;
	static int g_carId;
	static Simulation* g_pSimulation;
	static int g_simulationIterations;
	static int g_currentSimulationIteration;
	static int g_debugLevel;
	static int g_sleepInterval;
	static bool g_toggleFlag;
	static int g_simulationCount;
	static Statistics statistics;
	static double g_gossipPercent;
	static int g_bPublicInfo;
	static double g_gossipCarPercent;
	static int g_gossipQueueSize;
	static int g_gossipFactor;
	static double g_learningFactor;
	static double g_gossipLearningFactor;
	static int g_gossipLimitInfo;
	static int g_gossipEdgeRating;
	static int CarsPerLengthUnit;
	static bool g_showVisual;
	static CString BASE_PATH;
	static CString LOG_PATH;
	static CString STATISTICS_PATH;
	static CString XCEL_PATH;
	static char FILE_OPEN_PATH[MAX_FILE_PATH_LEN];
	static char BATCH_OPEN_PATH[MAX_FILE_PATH_LEN];
	static CString CARS_FILE_BASE_PATH;
	static int g_calculatingPercent;
	static int g_queueSize;
	static int g_index;
	static CString g_saveCarInfoPath;
	static CString g_carPath;
	static CString g_matrixDistFile;
	static bool g_bGossipUpdateProbability;

	static int g_liarFactor; // raz
	static int g_liarsNumber; // raz
	static int g_trueReliableFactor; // raz
	static int g_trueReliableNumber; // raz
	static CString g_liarCountPath;
	static int g_approvedNumberLiar; //raz 30-08-06
	static int g_approvedNumberTrueReliable; //12-03-07

public:
	static int getNextLiarId();
	static void calculateNextLiarId();
	static int getNextTrueReliableCarId();
	static void calculateNextTrueReliableCarId();

	static void SetPrintedInIteration(int carId, bool value);
	static void SetPrintedInSameIteration(int carId, bool value);
	static bool IsPrintedInIteration(int carId);
	static bool IsPrintedInSameIteration(int carId);
	static void InitPrintedCars();

	static int ReverseSlashFind(CString str);
	static int GetTokenIndex(){return g_index;}
	static CString GetToken(CString str,int startIndex,char delimiter);
	static CString GetNextToken(CString str,char delimiter,bool finish=false);
	static void init();
	static bool IsGossipMode();
	static bool SetToggle();
	static void incrememtTime();
	static bool isPublicInfo(){return g_bPublicInfo==1;}
	static bool isRealPublicInfo(){return g_bPublicInfo==2;}
	static void writeToFile(int level,const char *format, ...);
	static void writeLineToFile(int level,const char *format, ...);
	static void writeToFile(const char *format, ...);
	static void writeLineToFile(const char *format, ...);
	static void writeLineToString(CString& str,const char *format, ...);
	static void writeConfiguration(CStdioFile* pFile);
	static void openLog(CString file);
	static CString incrementFileName(CString path,CString file,CString suffix);
	static int getNextCarId();
	static void Clear();
	CentralInfo();
	virtual ~CentralInfo();
	static void PrintConsole(CString msg);//14-04-06 raz
	static void addGossipCarId(int carId);
	static bool isCarGossip(int carId);
	
	static void initGossipCarsIds();
private:
	static int m_gossipCarsId[MAX_GOSSIP_CARS];
	static int m_gossipCarIndex;
	//raz 09-09-06
	static int predefinedLiars[MAX_POSSIBLE_LIARS];
	static int nextLiarId;
	static int nextLiarIdIndex;
	static int predefinedTrueReliableCars[MAX_POSSIBLE_TRUE_RELIABLE_CARS];
	static int nextTrueReliableCarId;
	static int nextTrueReliableCarIdIndex;
};

#endif // !defined(AFX_CENTRALINFO_H__CB04B43C_CE30_4EE3_98BF_661ED561C991__INCLUDED_)
