// EdgesArray.cpp: implementation of the CEdgesArray class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VisualTransportationNetwork.h"
#include "EdgesArray.h"
#include "EdgeDetail.h"
#include "RoutingAlgo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEdgesArray::CEdgesArray()
{
/*	m_id = CentralInfo::temp++;
	CString msg;
	msg.Format("CED %d", m_id);
	CentralInfo::writeLineToFile(100, msg);
	*/
}

CEdgesArray::~CEdgesArray()
{
/*	CString msg;
	msg.Format("~CED %d", m_id);
	CentralInfo::writeLineToFile(100, msg);
*/	Clean();
}

int CEdgesArray::GetSize()
{
	return m_edgesDetails.GetSize();
}

EdgeDetail* CEdgesArray::GetAt(int index)
{
	return (EdgeDetail*)m_edgesDetails.GetAt(index);
}

void CEdgesArray::Clean()
{
	while (m_edgesDetails.GetSize() > 0)
	{
		EdgeDetail *pEdgeDetail = (EdgeDetail*)m_edgesDetails.GetAt(0);
		m_edgesDetails.RemoveAt(0);
		delete pEdgeDetail;
		pEdgeDetail = NULL;
	}
}

void CEdgesArray::Add(Edge *pEdge, bool freeData)
{
	EdgeDetail *pEdgeDetail = new EdgeDetail(pEdge);
	m_edgesDetails.Add(pEdgeDetail);

	if (freeData) 
	{
		delete pEdge;
		pEdge = NULL;
	}
}


void CEdgesArray::Add(EdgeDetail *pEdgeDetail, bool freeData)
{
	EdgeDetail *pNewEdgeDetail = new EdgeDetail(pEdgeDetail);
	m_edgesDetails.Add(pNewEdgeDetail);

	if (freeData)
	{
		delete pEdgeDetail;
		pEdgeDetail = NULL;
	}
}

void CEdgesArray::InsertAt(int index, Edge *pEdge, bool freeData)
{
	EdgeDetail *pEdgeDetail = new EdgeDetail(pEdge);
	m_edgesDetails.InsertAt(index, pEdgeDetail);

	if (freeData)
	{
		delete pEdge;
		pEdge = NULL;
	}
}

void CEdgesArray::InsertAt(int index, EdgeDetail *pEdgeDetail, bool freeData)
{
	EdgeDetail *pNewEdgeDetail = new EdgeDetail(pEdgeDetail);
	m_edgesDetails.InsertAt(index, pNewEdgeDetail);

	if (freeData) 
	{
		delete pEdgeDetail;
		pEdgeDetail = NULL;
	}
}

void CEdgesArray::RemoveAt(int index)
{
	EdgeDetail *pEdgeDetail = (EdgeDetail*)m_edgesDetails.GetAt(index);
	m_edgesDetails.RemoveAt(index);
	delete pEdgeDetail;
	pEdgeDetail = NULL;
}

void CEdgesArray::SetAt(int index, EdgeDetail *pEdgeDetail, bool freeData)
{
	EdgeDetail *pNewEdgeDetail = new EdgeDetail(pEdgeDetail);
	EdgeDetail *pTempEdgeDetail = (EdgeDetail*)m_edgesDetails.GetAt(index);
	m_edgesDetails.SetAt(index, pNewEdgeDetail);
	delete pTempEdgeDetail;
	pTempEdgeDetail = NULL;

	if (freeData)
	{
		delete pEdgeDetail;
		pEdgeDetail = NULL;
	}
}
