// GossipEdgeInfo.cpp: implementation of the GossipEdgeInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VisualTransportationNetwork.h"
#include "GossipEdgeInfo.h"
#include "Simulation.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GossipEdgeInfo::GossipEdgeInfo()
{
	m_lastTimeUpdate = 0;
	m_averageDelayTrueData = 0;//raz 26-04-06, splitting to updates of true data and false data
	m_averageDelayFalseData = 0;
	m_updateTimesTrueData = 0;//raz 26-04-06, splitting to updates of true data and false data
	m_updateTimesFalseData = 0;
	m_trafficLoad = -1;
	
	m_bOpposite = true;
}

void GossipEdgeInfo::Init(int edgeId, int fromEdgeId,int distance,bool opposite)
{
	m_edgeId = edgeId;
	m_fromEdgeId = fromEdgeId;
	m_dist = distance;
	m_bOpposite = opposite; 
}

void GossipEdgeInfo::Calc(int time, WORD dataType)
{
	if(CentralInfo::g_simulationCount<CentralInfo::g_simulationLength && time>m_lastTimeUpdate)
	{
		//raz 24-04-06 splitting between updates of true data and false data
		if (dataType == CentralInfo::TRUE_DATA)
		{
			m_updateTimesTrueData++;
			m_averageDelayTrueData+=CentralInfo::g_currentTime-time;
		}
		else if (dataType == CentralInfo::FALSE_DATA)
		{
			m_updateTimesFalseData++;
			m_averageDelayFalseData+=CentralInfo::g_currentTime-time;
		}
		m_str.Format("%d ",/*CentralInfo::g_currentTime-*/time);
		m_timeStr+=m_str;
		
		m_lastTimeUpdate = time;
	}
}

GossipEdgeInfo::~GossipEdgeInfo()
{

}

int GossipEdgeInfo::GetTrafficLoad()
{
	return m_trafficLoad;
}
