// GossipInfo.cpp: implementation of the GossipInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VisualTransportationNetwork.h"
#include "GossipInfo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GossipInfo::GossipInfo()
{
	pEdgeInfo = NULL;
}

void GossipInfo::Create(int count)
{
	m_size = count;
	pEdgeInfo = new GossipEdgeInfo*[m_size];
	for(int i=0;i<m_size;i++)
		pEdgeInfo[i] = new GossipEdgeInfo[m_size];

}

void GossipInfo::Calc(int id,int fromId,int time, WORD dataType)
{
	int *pId=NULL,*pFromId=NULL;
	m_edgeMap.Lookup(id,(void*&)pId);
	m_edgeMap.Lookup(fromId,(void*&)pFromId);
	if(pFromId!=NULL && pId!=NULL)
		pEdgeInfo[*pId][*pFromId].Calc(time, dataType);
}

void GossipInfo::TrafficLoad(int id)
{
	int *pId=NULL;
	m_edgeMap.Lookup(id,(void*&)pId);
	if(pId!=NULL)
		pEdgeInfo[*pId][0].m_trafficLoad++;
}

GossipInfo::~GossipInfo()
{
	WORD key;
	void* p;
	POSITION pos = m_edgeMap.GetStartPosition();
	while(pos)
	{
		p=NULL;
		m_edgeMap.GetNextAssoc(pos,key,(void*&)p);
		delete p;
	}

	if(pEdgeInfo)
	{
		for(int i=0;i<m_size;i++)
			delete[] pEdgeInfo[i];

		delete[] pEdgeInfo;
	}

}
