// GossipLearning.h: interface for the GossipLearning class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GOSSIPLEARNING_H__C373484D_EF52_4118_BC1D_BD80804906CE__INCLUDED_)
#define AFX_GOSSIPLEARNING_H__C373484D_EF52_4118_BC1D_BD80804906CE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "RoutingAlgo.h"
#include "EdgesArray.h"

const int RANDOM_WEIGHT_BASE_START = 190;//1000;//190;

class GossipLearning : public RoutingAlgo  
{
protected:
	int m_numOfJunctions;
	int* m_locMatrix;
	int* m_revertLocMatrix; //raz 07-06-06
	double* m_vertixVal;
	double* m_revertVertixVal; //raz 07-06-06
	CEdgesArray m_edges;
	CEdgesArray m_pEdgeRate;
	CEdgesArray m_pLiarEdgeRate;
	CEdgesArray m_currentInfo;
	int m_edgeLimitNum;
	bool m_bCalcRouteOnce;
public:
	void CurrentInfo(EdgeDetail* pEdge);
	void ClearInfo();
	void Test(int id);
	CEdgesArray* GetCurrentInfo(){
		int size = m_currentInfo.GetSize();
		return &m_currentInfo;
	}
	void UpdateRating(EdgeDetail* pEdge,int rating);
	void CreateRating();
	void RandEdges();
	void Init();
	void Load(CPtrArray* pEdges,int numOfJunctions);
	bool UpdateEdges(int road,int fromCar,int toCar,CEdgesArray* pEdges,int maxDist, bool bIsLiarCar, bool bIsTrueReliableCar);
	bool UpdateEdge(int roadId, double weight,int time, /*raz 03-06-06*/ int nCarID, bool bIsTrueReliableCar);
	CEdgesArray* GetEdges();
	CEdgesArray* GetRatedEdges(/*raz 25-02-06*/bool bIsLiarCar, bool bIsTrueReliableCar, /*raz 03-06-06*/int nCarID, CMapWordToPtr& routeTable);
	void Build(double** matrix,int numOfJunctions);
	void Calc(int source);
	void Clear();
	void Revert(); //raz 07-06-06
	CString ShortestPath(int i, int j);
	double Distance(int destination); 
	void Update(int from, int to, double value,int time, /*raz 03-06-06*/int nCarID, bool bIsTrueReliableCar);
	void UpdateCurrentEdge(int from, int to, double value,int time);
	void BuildPath(int i, int j,CMapWordToPtr& routeTable, /*raz 09-06-06*/bool bCalcOnce, /*raz 20-07-06*/int &length);
	bool IsLearningGap(double last,double current)
	{
		if(abs(current-last)>1)
			return true;
		return false;
	}
	GossipLearning();
	virtual ~GossipLearning();
	CString GetShortestPathWeight(); //raz 15-07-06

private:
	CString m_shortestPathWeight;
};

#endif // !defined(AFX_GOSSIPLEARNING_H__C373484D_EF52_4118_BC1D_BD80804906CE__INCLUDED_)
