// ISimulation.h: interface for the ISimulation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ISIMULATION_H__C3D838BD_96DD_4F0F_B26D_2DAF41F6C08E__INCLUDED_)
#define AFX_ISIMULATION_H__C3D838BD_96DD_4F0F_B26D_2DAF41F6C08E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IVisualNetwork.h"

class ISimulation 
{
public:
	virtual void Create(IVisualNetwork* pObj)=0;
	virtual void Load(IVisualNetwork* pObj,CStdioFile* pFile)=0;
	virtual void Save(CStdioFile* pFile)=0;
	virtual void Simulate(IVisualNetwork* pObj,CStdioFile* pFile)=0;
	virtual void Stop()=0;
	virtual void AddCarRule(int number,int source, int destination)=0;
	virtual void AddTrafficRule(int road,int step, int value,int stepLength,int iteration)=0;
	virtual int GetNumOfReturnedCars()=0;
	virtual bool IsNeigbour(int junction1,int junction2)=0;
	virtual int GetDistance(int u,int v)=0;
	virtual void RemoveTrafficRules()=0;
	virtual bool IsOppositeRoads(int id1,int id2)=0;
	virtual ~ISimulation();

};

#endif // !defined(AFX_ISIMULATION_H__C3D838BD_96DD_4F0F_B26D_2DAF41F6C08E__INCLUDED_)
