// Junction.h: interface for the Junction class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JUNCTION_H__34575FB0_4AEF_4F42_AA7A_5632ACD3155B__INCLUDED_)
#define AFX_JUNCTION_H__34575FB0_4AEF_4F42_AA7A_5632ACD3155B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TrafficLight.h"
#include "IJunction.h"

class Road;
class Car;
class IJunctionShape;


class Junction : public IJunction  
{
public:
	CMapWordToPtr m_startRoads;
	CPtrArray m_endRoads;
	IJunctionShape* pShape;

public:
	int m_Id;
	TrafficLight m_trafficLight;

public:
	void AddStartRoad(Road* pRoad);
	void AddEndRoad(Road* pRoad);
	CString toString();
	void CalcOppositeRoads();
	void SetShape(IJunctionShape* pObj);
	void Save(CStdioFile* pFile);
	void Load(CStdioFile* pFile);
	void Execute();
	void SwapJunctionInfo();
	Junction(IJunctionShape* pObj);
	Junction();
	virtual ~Junction();

};

#endif // !defined(AFX_JUNCTION_H__34575FB0_4AEF_4F42_AA7A_5632ACD3155B__INCLUDED_)
