// JunctionShape.h: interface for the JunctionShape class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JUNCTIONSHAPE_H__7372E926_86BA_49CC_9D9E_E6D5911637D2__INCLUDED_)
#define AFX_JUNCTIONSHAPE_H__7372E926_86BA_49CC_9D9E_E6D5911637D2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Shape.h"
#include "IJunctionShape.h"

class JunctionShape : public IJunctionShape, public Shape 
{
protected:
	CRect m_rect;
	COLORREF m_light;
	static int g_idCount;
	IJunction* m_pJunction;
	bool m_bSelect;

public:
	//IJunctionShape interface
	int GetId();
	void Update();
	void SetJunction(IJunction* pJunction){m_pJunction=pJunction;}


public:
	void SetSelected(bool select);
	void SetLight(int light);
	void Draw(CDC* pDC);
	JunctionShape();
	bool Complete(CPoint point);
	bool Contains(CPoint point);
	bool Load(CStdioFile *pFile);
	void Save(CStdioFile *pFile);
	static int GetNextId(){return ++g_idCount;}
	virtual ~JunctionShape();

};

#endif // !defined(AFX_JUNCTIONSHAPE_H__7372E926_86BA_49CC_9D9E_E6D5911637D2__INCLUDED_)
