// NetworkInfo.cpp: implementation of the NetworkInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VisualTransportationNetwork.h"
#include "NetworkInfo.h"
#include "GossipLearning.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

NetworkInfo::NetworkInfo()
{

	m_networkMatrixDistance = NULL;
	m_size = 0;
}

NetworkInfo::~NetworkInfo()
{
	for(int i=0;i<m_size;i++)
		delete[] m_networkMatrixDistance[i];

	if (m_networkMatrixDistance != NULL)
		delete[] m_networkMatrixDistance;
}

void NetworkInfo::Create(Network* pNetwork)
{
	m_size = pNetwork->GetNumberOfJunctions();
	m_networkMatrixDistance = new int*[m_size];
	for(int i=0;i<m_size;i++)
		m_networkMatrixDistance[i] = new int[m_size];


	for(i=0;i<pNetwork->m_JunctionList.GetSize();i++)
	{
		GossipLearning algo;
		algo.Build(pNetwork->m_networkMatrix,pNetwork->GetNumberOfJunctions());
		algo.Calc(i+1);
		for(int j=0;j<pNetwork->m_JunctionList.GetSize();j++)
		{
			m_networkMatrixDistance[i][j]=algo.Distance(j+1);	
		}
	}
}

int NetworkInfo::GetDistance(int i, int j)
{
	return m_networkMatrixDistance[i-1][j-1];
}
