// Road.h: interface for the Road class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROAD_H__7F941828_E1CC_4557_8934_CB3CF346DE0E__INCLUDED_)
#define AFX_ROAD_H__7F941828_E1CC_4557_8934_CB3CF346DE0E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IRoad.h"
class Car;
class IRoadShape;

class CEdgesArray;

class RoadTimeInfo
{
public:
	int timeValue;
	int time;
	int car;
public:
	RoadTimeInfo(){}
	void SetInfo(int val,int carId)
	{
		timeValue = val;
		time = CentralInfo::g_currentTime;
		car = carId;
	}
	
};

class Road : public IRoad 
{
public:
	int GetMaxQueueSize();
	void MoveToQueue();
	CPtrArray m_arrayOfCars;
	CPtrArray m_queueOfCars;
	DWORD m_velocity;
	IRoadShape* pShape;
	Road* m_pOppositeRoad;
	int m_carsLeftToRemove;
	CMapWordToPtr m_roadInfo;
public:
	bool m_bIsOpened;
	int m_startJuncId;
	int m_endJuncId;
	int m_id;
	int m_gossipCount;
	int m_gossipTotalCount;
	double m_updateCountTrueData,m_updateCountFalseData,m_notUpdateCountTrueData,m_notUpdateCountFalseData;
	DWORD m_length;
	bool m_isStartingRoad;
	int m_carsPerStep;
	static int g_defaultVelocity;
	static int g_defaultLength;
public:
	int GetMaxTime();
	Car* GetNextCar();
	CPtrArray* GetGossipCars(int num);
	void RemoveCar();
	void UpdateRoad(Car* pCar);
	void CalcUpdateRate(CEdgesArray* pCurrentInfo,CString& strNotUpdated);
	void SetJamInfo(int emptyPlaces,double weight);
	int GetNumberOfCars();
	int GetNumOfEmptyPlaces();
	void SetCarsLeftToRemove();
//	Car* RemoveCar(int carId,int junctionId);
	void SetOppositeRoad(Road* pRoad);
	// IRoad interface
	void SetVelocity(int velocity){m_velocity=velocity;}
	void SetLength(int length){m_length=length;}
	void SetAsStartingRoad(bool start){m_isStartingRoad=start;}
	int  GetVelocity(){return m_velocity;}
	int GetCarsPerStep()
	{
		if(m_carsPerStep==-1)
			return CentralInfo::g_carsPerStep;
		return m_carsPerStep;
	}
	void SetCarsPerStep(int cars){m_carsPerStep=cars;}
	int GetLength(){return m_length;}
	int GetQueueSize(){return m_queueOfCars.GetSize();}
	double GetWeight();
	bool GetAsStartingRoad(){return m_isStartingRoad;}
	void SetTrafficLoad();
	void SetShape(IRoadShape* pObj);
	void Road::Init();
	void Save(CStdioFile* pFile);
	void Load(CStdioFile* pFile);
	bool IsGreenLight();
	void Execute();
	void RemoveCars(CPtrArray &cars);
	void InsertCars(CPtrArray cars);
	void InsertCar(Car* pCar);
	void InsertCarToQueue(Car* pCar);
	bool HasRoadFinished(Car* pCar);
	static int getRoadId(int startJuncId,int endJuncId);
//	void GossipAlgo(Car* pCar,CPtrArray& array,double oppositeWeight);
	void GossipAlgo(CPtrArray& myArray,CPtrArray& array,double oppositeWeight);
	void Gossip();
	void GetGossipCars(CPtrArray& array);
	Road(IRoadShape* Obj);
	Road();
	virtual ~Road();

};

#endif // !defined(AFX_ROAD_H__7F941828_E1CC_4557_8934_CB3CF346DE0E__INCLUDED_)
