// RoadShape.h: interface for the RoadShape class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROADSHAPE_H__71CE9895_2DF5_47EA_9462_65781EE447AA__INCLUDED_)
#define AFX_ROADSHAPE_H__71CE9895_2DF5_47EA_9462_65781EE447AA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Shape.h"
#include "IRoadShape.h"

class JunctionShape;

class RoadShape : public IRoadShape,public Shape  
{
protected:
	int m_startJunctionId;
	int m_endJunctionId;
	CRect m_rect;
	IRoad* m_pRoad;
	COLORREF m_currentLoad;

public:
	int GetStartJunctionId(){return m_startJunctionId;}
	int GetEndJunctionId(){return m_endJunctionId;}
	int GetId(){return m_id;}
	void Update();
	void SetRoad(IRoad* pRoad)
	{
		m_pRoad=pRoad;
	}
	void SetTrafficLoad(int load,int max);


public:
	static int getRoadId(int startJuncId,int endJuncId);
	void Draw(CDC* pDC);
	RoadShape();
	IRoad* GetRoad(){return m_pRoad;}
	bool Complete(CPoint point);
	bool Init(CPtrArray* pShapeArray,CPoint point);
	JunctionShape* GetContainingShape(CPoint point);
	bool Load(CStdioFile *pFile);
	void Save(CStdioFile *pFile);
	void CalcTextPos(CDC* pDC);
	void SetProperties();
	void SetRect();
	bool Contains(CPoint point);
	virtual ~RoadShape();

};

#endif // !defined(AFX_ROADSHAPE_H__71CE9895_2DF5_47EA_9462_65781EE447AA__INCLUDED_)
