// RoutingAlgo.h: interface for the RoutingAlgo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROUTINGALGO_H__5C7B530A_50A9_4F70_8ADD_0D5CC6BC8811__INCLUDED_)
#define AFX_ROUTINGALGO_H__5C7B530A_50A9_4F70_8ADD_0D5CC6BC8811__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Edge
{
public:
	int u;
	int v;
	double weight;
//	double previousWeight;
	double currentWeight;
	int weightTime;
	int originator; //raz 03-06-06
	int iterationOrigin; //raz 09-08-06
//	int lastWeightTime;
//	int averageWeightTime;
//	int timeUpdates;
//	bool bHaveTransit;
	int m_id;
	int rating;
	WORD m_dataType; /*whether this data is a TRUE data (CentralInfo::TRUE_DATA) -
					only applicable when loading the network
					or FALSE data (generated by liars) CentralInfo::FALSE_DATA -
					it is only used in the statistics. 
					Regular gossip cars are unaware of this.
					True reliable cars are aware of this and discard these edges
					*/


	Edge(int u,int v,double w, WORD dataType);
	Edge(const Edge& edge);
	Edge(const Edge* pEdge);

	virtual ~Edge(){}

Edge& operator=(const Edge& edge) { //raz 15-07-06
	this->u = edge.u;
	this->v = edge.v;
	this->weight = edge.weight;
	this->currentWeight = edge.currentWeight;
	this->weightTime = edge.weightTime;
	this->originator = edge.originator;
	this->iterationOrigin = edge.iterationOrigin; //raz 09-08-06
	this->m_id = edge.m_id;
	this->rating = edge.rating;
	this->m_dataType = edge.m_dataType;
	return *this; 
} 

};

class Num
{
public:
	int m_id;
	Num(int id)
	{
		m_id=id;
	}
};

class CEdgesArray;

class RoutingAlgo  
{
public:
	virtual void Load(CPtrArray* pEdges,int numOfJunctions)=0;
	virtual bool UpdateEdges(int road,int fromCar,int toCar,CEdgesArray* pEdges,int maxDist, bool bIsLiarCar, bool bIsTrueReliableCar)=0;
	virtual bool UpdateEdge(int roadId, double weight,int time, /*raz 03-06-06*/ int nCarID, bool bIsTrueReliableCar)=0;
	virtual CEdgesArray* GetEdges()=0;
	virtual CEdgesArray* GetRatedEdges(/*raz 25-02-06*/bool bIsLiarCar,bool bIsTrueReliableCar,/*raz 03-06-06*/int nCarID, CMapWordToPtr& routeTable)=0;
	virtual CEdgesArray* GetCurrentInfo()=0;
	virtual void Init()=0;
	virtual void Build(double** matrix,int numOfJunctions)=0;
	virtual void Calc(int source)=0;
	virtual void Revert()=0;//raz 07-06-06
	virtual void Clear()=0;
	virtual CString ShortestPath(int i, int j)=0;
	virtual void Update(int from, int to, double value,int time, /*raz 03-06-06*/int nCarID, bool bIsTrueReliableCar)=0;
	virtual void UpdateCurrentEdge(int from, int to, double value,int time)=0;
	virtual void BuildPath(int i, int j,CMapWordToPtr& routeTable, /*raz 09-06-06*/bool bCalcOnce, /*raz 20-07-06*/int &length)=0;
	virtual double Distance(int destination)=0; 
	virtual CString GetShortestPathWeight()=0;
	virtual ~RoutingAlgo();

};

#endif // !defined(AFX_ROUTINGALGO_H__5C7B530A_50A9_4F70_8ADD_0D5CC6BC8811__INCLUDED_)
