// Shape.cpp: implementation of the Shape class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VisualTransportationNetwork.h"
#include "Shape.h"

#define START_POINT_INDEX 11
#define END_POINT_INDEX 9
#define SHAPE_ID 3

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Shape::Shape()
{

}

Shape::~Shape()
{

}

shapeType Shape::GetType()
{
	return m_type;
}

bool Shape::Init(CPtrArray* pShapeArray,CPoint point)
{
	m_pShapeList=pShapeArray;
	m_bComplete = false;
	m_startPoint = point;
	return true;
}
void Shape::UpdatePos(CPoint point)
{
	m_endPoint=point;
}

bool Shape::Complete(CPoint point)
{
	m_bComplete = true;
	m_endPoint=point;
	return true;
}

bool Shape::Contains(CPoint point)
{
	return false;
}

void Shape::Save(CStdioFile *pFile)
{
	CString strStart,strEnd,strId;
	strStart.Format("StartPoint %d %d\n",m_startPoint.x,m_startPoint.y);
	strEnd.Format("EndPoint %d %d\n",m_endPoint.x,m_endPoint.y);
	strId.Format("Id %d\n",m_id);
	pFile->WriteString(strId);
	pFile->WriteString(strStart);
	pFile->WriteString(strEnd);
}

bool Shape::Load(CStdioFile *pFile)
{
	CString str;
	int index;
	pFile->ReadString(str);
	m_id=atoi(LPCSTR(str.Mid(SHAPE_ID,str.GetLength()-SHAPE_ID)));
	pFile->ReadString(str);
	index=str.Find(" ",START_POINT_INDEX);
	m_startPoint.x=atoi(LPCSTR(str.Mid(START_POINT_INDEX,index-START_POINT_INDEX)));
	m_startPoint.y=atoi(LPCSTR(str.Mid(++index,str.GetLength()-index)));
	pFile->ReadString(str);
	index=str.Find(" ",END_POINT_INDEX);
	m_endPoint.x=atoi(LPCSTR(str.Mid(END_POINT_INDEX,index-END_POINT_INDEX)));
	m_endPoint.y=atoi(LPCSTR(str.Mid(++index,str.GetLength()-index)));
	return true;
}
