// Simulation.h: interface for the Simulation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SIMULATION_H__0282CDD0_CFAA_4533_9AD2_EF88BEBAA86C__INCLUDED_)
#define AFX_SIMULATION_H__0282CDD0_CFAA_4533_9AD2_EF88BEBAA86C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Network.h"
#include "ISimulation.h"
#include "Statistics.h"
#include "GossipInfo.h"
#include "NetworkInfo.h"

class Car;
class IVisualNetwork;
class Simulation : public ISimulation  
{
public:
	int temp;//@@
	Network m_network;
	NetworkInfo m_networkInfo;
	GossipInfo m_gossipInfo;
	CPtrArray* m_carListArray[2];

	int m_carNum;
	int m_carStatisticNum;
	int m_PreviousCarStatisticNum;
	bool m_bFinish;
	bool m_bStuck;
	int m_stuckCount;
	bool m_bLoadCars;
	Statistics statistics;
	static int g_roadsNum;
//	CPtrArray m_carList;
//	CPtrArray m_nextCarList;
public:
	int CalcIntensity(int step,int ruleIndex);
	//ISimulation interface
	void Create(IVisualNetwork* pObj);
	void BuildGossipInfo();
	void Load(IVisualNetwork* pObj,CStdioFile* pFile);
	void Stop(){m_bFinish=true;}
	int GetNumOfReturnedCars(){return m_carNum;}
	bool isStageCleared();
	int GetNumOfCarsInStatistics();
	bool IsInStatisticScope(int id);
	bool isSimulationStageOver();
	void SortCars();
	void CheckIfStuck();
	void Simulate(IVisualNetwork* pObj,CStdioFile* pFile);
	void AddCarToList();
	void ReturnCar(Car* pCar,bool finish = true);
	void Save(CStdioFile* pFile);
	void AddCarRule(int number,int source, int destination);
	void AddTrafficRule(int road,int step, int value,int stepLength,int iteration);
	bool IsNeigbour(int junction1,int junction2);
	int GetDistance(int u,int v);
	void SaveCarInfo(CStdioFile* pFile);
	int GetCarDelay();
	void RemoveTrafficRules();
	bool IsOppositeRoads(int id1,int id2);
	Simulation();
	virtual ~Simulation();

};

#endif // !defined(AFX_SIMULATION_H__0282CDD0_CFAA_4533_9AD2_EF88BEBAA86C__INCLUDED_)
