// Statistics.h: interface for the Statistics class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STATISTICS_H__195CE1C5_3FC4_475E_8D10_520EE4DD4BA8__INCLUDED_)
#define AFX_STATISTICS_H__195CE1C5_3FC4_475E_8D10_520EE4DD4BA8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CarInfo
{
public:
	CString m_carPath;
	int m_totalTime;
	int m_delayTime;
	int m_carId;
	int step;
	int m_type; //0-regular 1-gossip 2-public
	bool m_bTraffic;
	/*RAZ*/DWORD m_initialStartTime;
	/*RAZ*/bool m_bIsLiar;
	bool m_bIsTrueReliableCar;
	CarInfo(/*RAZ*/DWORD startTime, int carId,CString carPath,int totalTime,int delayTime,int type,bool bTraffic,/*RAZ*/bool isLiar = FALSE, bool isTrueReliableCar = FALSE);
};

class RoadInfo
{
public:
	int m_carsPerStep;
	CPtrArray loadList;
	double loadAverage;
	int id;
	RoadInfo()
	{
		loadAverage = 0;
		m_carsPerStep = 0;
	}
	void SetLoad(double load)
	{
		AddVal(loadList,load);
	}
	void SetQueueSize(int size)
	{
		m_carsPerStep = size;
	}
};

class DelayInfo
{
public:
	int m_delay;
	int m_value;
	DelayInfo(int delay,int value)
	{
		m_delay=delay;
		m_value=value;
	}
};

class Statistics  
{
public:
	bool m_bInit;
	CPtrArray m_carsInfo;
	CPtrArray m_gossipCarsInfo;
	CPtrArray m_publicCarsInfo;
	CStdioFile m_file;
	CStdioFile m_xcelfile;
	CStdioFile m_xcel2file;
	CStdioFile m_xcel3file;
	CStdioFile m_xcelGossipfile;
	CStdioFile m_xcelGossipLearningProbabilityFile;
	CMapWordToPtr m_roadInfo;
public:
	void WriteMatrixDistance(CString path);
	void StopAtStuck(int num);
	void Stuck(int num);
	void Start();
	void AddRoadInfo(int id,double load,int size);
	void Init(CString path);
	void Clear();
	void AddGossipCarInfo(/*RAZ*/DWORD startTime, int carId, CString carPath, int totalTime,int delayTime, bool bTraffic,bool isLiar/*RAZ*/, bool isTrueReliableCar);
	void AddPublicCarInfo(/*RAZ*/DWORD startTime, int carId, CString carPath, int totalTime,int delayTime, bool bTraffic);
	void WriteNetwork(double& averageNetworkLoad);
	void WriteNetworkLoad(CStdioFile* pFile);
	void CompareGossipTime(CStdioFile* pFile);
	void WriteCars(CPtrArray& cars,int& averageTime,CMapWordToPtr& delayInfo);
	void WriteInfo(int iteration);
	void AddCarInfo(/*RAZ*/DWORD startTime, int carId,CString carPath,int totalTime,int delayTime, bool bTraffic);
	double saverage(double average);
	void WriteDelayInfo(CMapWordToPtr& delayInfo);
	void WriteGossipInfo();
	void WriteUpdateProbabilityLine(CString line, bool flush = false);//14-04-06 RAZ
	void Close();
	Statistics();
	virtual ~Statistics();

};

#endif // !defined(AFX_STATISTICS_H__195CE1C5_3FC4_475E_8D10_520EE4DD4BA8__INCLUDED_)
