// VisualTransportationNetwork.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "VisualTransportationNetwork.h"

#include "MainFrm.h"
#include "VisualTransportationNetworkDoc.h"
#include "VisualTransportationNetworkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVisualTransportationNetworkApp

BEGIN_MESSAGE_MAP(CVisualTransportationNetworkApp, CWinApp)
	//{{AFX_MSG_MAP(CVisualTransportationNetworkApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVisualTransportationNetworkApp construction

CVisualTransportationNetworkApp::CVisualTransportationNetworkApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CVisualTransportationNetworkApp object

CVisualTransportationNetworkApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CVisualTransportationNetworkApp initialization

BOOL CVisualTransportationNetworkApp::InitInstance()
{
	AfxEnableControlContainer();

	//14-04-06 raz 
	// allocate a console
//#ifdef _DEBUG
	if (!AllocConsole())
		AfxMessageBox("Failed to create the console!", MB_ICONEXCLAMATION);
//#endif
//	return TRUE;

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	SetRegistryKey(_T("GossipApp"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CVisualTransportationNetworkDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CVisualTransportationNetworkView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	LoadGeneralParameters();

	if (CentralInfo::g_runOutsideGui == 1)
	{
		((CVisualTransportationNetworkView*)((CFrameWnd*)m_pMainWnd)->GetActiveView())->Simulate();
		return FALSE;
	}
	
	else
		return TRUE;
}

BOOL CVisualTransportationNetworkApp::LoadGeneralParameters()
{
	// read the generalParameters.txt file to update the parameters based on this run
	CString line, param, value;
	CStdioFile paramsFile;
	char strDir[256];
	::GetCurrentDirectory(256,strDir);
	CentralInfo::BASE_PATH=strDir;
	if(!paramsFile.Open(CentralInfo::BASE_PATH + "\\generalParameters.txt",CFile::modeRead| CFile::shareDenyNone))
		return FALSE;
	while(paramsFile.ReadString(line) && line !="")
	{
		param = CentralInfo::GetToken(line,0,'=');
		value = CentralInfo::GetNextToken(line,'=',true);

		if (param == "Configuration")
			CentralInfo::CARS_FILE_BASE_PATH = value;
		else if (param == "LogPath")
			CentralInfo::LOG_PATH = value;
		else if (param == "DebugLevel")
			CentralInfo::g_debugLevel = atoi(value);
		else if (param == "RunOutsideGui")
			CentralInfo::g_runOutsideGui = atoi(value);
	}


	CStdioFile gossipCarsFile;
	CentralInfo::initGossipCarsIds();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CVisualTransportationNetworkApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CVisualTransportationNetworkApp message handlers

