// XcelDataContainer.cpp: implementation of the XcelDataContainer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VisualTransportationNetwork.h"
#include "XcelDataContainer.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

XcelDataContainer::XcelDataContainer()
{

}

XcelDataContainer::~XcelDataContainer()
{

}

void XcelDataContainer::Average(bool bNormalize)
{
	m_averageList.SetSize(((XcelData*)m_dataList.GetAt(0))->GetSize());
	XcelData* pData;
	double val;
	for(int i=0;i<m_dataList.GetSize();i++)
	{
		pData = (XcelData*)m_dataList.GetAt(i);
		for(int j=0;j<pData->GetSize();j++)
		{
			if(bNormalize)
				val = pData->GetNormalizedValue(j);
			else
				val = pData->GetValue(j);

			SetVal(m_averageList,j,GetVal(m_averageList,j)+val);
		}
	}
	for(i=0;i<m_averageList.GetSize();i++)
	{
		SetVal(m_averageList,i,GetVal(m_averageList,i)/GetSize());
	}
}

void XcelDataContainer::SpecialAverage()
{
	m_specialAverageList.SetSize(((XcelData*)m_dataList.GetAt(0))->GetSize());
	XcelData* pData;
	double val;
	for(int i=0;i<m_dataList.GetSize();i++)
	{
		pData = (XcelData*)m_dataList.GetAt(i);
		for(int j=0;j<pData->GetSize();j++)
		{
			val = pData->GetSpecialValue(j);
			SetVal(m_specialAverageList,j,GetVal(m_specialAverageList,j)+val);
		}
	}
	for(i=0;i<m_averageList.GetSize();i++)
	{
		SetVal(m_specialAverageList,i,GetVal(m_specialAverageList,i)/GetSize());
	}
}

void XcelDataContainer::NetworkLoadAverage()
{
	m_networkLoadAverage.SetSize(((XcelData*)m_dataList.GetAt(0))->GetSize());
	XcelData* pData;
	double val;
	for(int i=0;i<m_dataList.GetSize();i++)
	{
		pData = (XcelData*)m_dataList.GetAt(i);
		for(int j=0;j<pData->GetSize();j++)
		{
			val = pData->GetNetworkLoadValue(j);
			SetVal(m_networkLoadAverage,j,GetVal(m_networkLoadAverage,j)+val);
		}
	}
	for(i=0;i<m_averageList.GetSize();i++)
	{
		SetVal(m_networkLoadAverage,i,GetVal(m_networkLoadAverage,i)/GetSize());
	}
}

void XcelDataContainer::STNetworkLoadAverage()
{
	m_stNetworkLoadAverage.SetSize(((XcelData*)m_dataList.GetAt(0))->GetSize());
	XcelData* pData;
	double val;
	for(int i=0;i<m_dataList.GetSize();i++)
	{
		pData = (XcelData*)m_dataList.GetAt(i);
		for(int j=0;j<pData->GetSize();j++)
		{
			val = pData->GetSTNetworkLoadValue(j);
			SetVal(m_stNetworkLoadAverage,j,GetVal(m_stNetworkLoadAverage,j)+val);
		}
	}
	for(i=0;i<m_stNetworkLoadAverage.GetSize();i++)
	{
		SetVal(m_stNetworkLoadAverage,i,GetVal(m_stNetworkLoadAverage,i)/GetSize());
	}
}


void XcelDataContainer::ST(bool bNormalize)
{
	double val;
	XcelData* pData;
	m_STList.SetSize(((XcelData*)m_dataList.GetAt(0))->GetSize());
	for(int i=0;i<m_dataList.GetSize();i++)
	{
		pData = (XcelData*)m_dataList.GetAt(i);
		for(int j=0;j<pData->GetSize();j++)
		{
			if(bNormalize)
				val = pData->GetNormalizedValue(j);
			else
				val = pData->GetValue(j);
			val = GetVal(m_averageList,j)-val;
			val *= val;
			SetVal(m_STList,j,GetVal(m_STList,j)+val);
		}
	}
	for(i=0;i<m_STList.GetSize();i++)
	{
		SetVal(m_STList,i,sqrt(GetVal(m_STList,i)/GetSize()));
	}

}

int XcelDataContainer::GetSize()
{
	return m_dataList.GetSize();
}

void XcelDataContainer::WriteNormalize()
{
	XcelData* pData;
	for(int i=0;i<m_dataList.GetSize();i++)
	{
		pData = (XcelData*)m_dataList.GetAt(i);
		pData->Write();
	}
}

void XcelDataContainer::WriteAverage(CString fileName)
{
	CString str;
	CStdioFile outputFile;
	outputFile.Open(fileName,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	for(int i=0;i<m_averageList.GetSize();i++)
	{
		str.Format("%0.2f\n",GetVal(m_averageList,i));
		outputFile.WriteString(str);
	}
}

void XcelDataContainer::WriteST(CString fileName)
{
	CString str;
	CStdioFile outputFile;
	outputFile.Open(fileName,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	for(int i=0;i<m_STList.GetSize();i++)
	{
		str.Format("%0.2f\n",GetVal(m_STList,i));
		outputFile.WriteString(str);
	}
}