// XcelDetailData.cpp: implementation of the XcelDetailData class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VisualTransportationNetwork.h"
#include "XcelDetailData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

XcelDetailData::XcelDetailData(CString folderName,int type,double percent)
{
	m_folderName = folderName;
	m_type = type;
	m_percent = percent;
	switch(m_type)
	{
		case 0:
			m_fileName = "/regular_detail.txt";
			break;
		case 1:
			m_fileName = "/gossip_detail.txt";
			break;
		case 2:
			m_fileName = "/public_detail.txt";
			break;
		case 3:
			m_fileName = "/realPublic_detail.txt";
			break;
	};
}


XcelDetailData::~XcelDetailData()
{

}


void XcelDetailData::ReadData(double& min,double& max) 
{
	CString line,startLine="regular delay (delay value):";
	CStdioFile file;
	if(!file.Open(m_folderName+m_fileName,CFile::modeReadWrite | CFile::shareDenyNone))
		return;
	while(file.ReadString(line))
	{
		if(line==startLine)
			break;
	}
	int id,val,lastId=-1;
	while(file.ReadString(line) && line!="")
	{
		id = atof(CentralInfo::GetToken(line,0,' '));
		val = atof(CentralInfo::GetNextToken(line,' ',true));
		max = max(id,max);
		min = min(id,min);
		while(id>lastId+1)
		{
			lastId++;
			AddVal(m_data1,0);
		}
		AddVal(m_data1,val);
		lastId=id;
	}
	
	if(m_type==1)
		startLine = "gossip delay (delay value):";
	else if(m_type==2 || m_type==3)
		startLine = "public delay (delay value):";

	while(file.ReadString(line))
	{
		if(line==startLine)
			break;
	}
	lastId=-1;
	while(file.ReadString(line))
	{
		id = atof(CentralInfo::GetToken(line,0,' '));
		val = atof(CentralInfo::GetNextToken(line,' ',true));
		max = max(id,max);
		min = min(id,min);
		while(id>lastId+1)
		{
			lastId++;
			AddVal(m_data2,0);
		}
		AddVal(m_data2,val);
		lastId=id;
	}

}

double XcelDetailData::GetValue(int index)
{
	double average=0;
	if(m_type==0)
	{
		if(index>=m_data1.GetSize())
			average=-1;
		else
			average = GetVal(m_data1,index);
	}
	else
	{
		if(index>=m_data1.GetSize() && index>=m_data2.GetSize())
			average=-1;
		else
		{
			average=0;
			if(index<m_data1.GetSize())
				average += GetVal(m_data1,index);
			if(index<m_data2.GetSize())
				average += GetVal(m_data2,index);
		}
	}
	return average;
}

double XcelDetailData::GetSpecialValue(int index)
{
	double average=0;
	if(m_type==0)
	{
		if(index>=m_data1.GetSize())
			average = -1;
		else
			average = ((double)GetVal(m_data1,index));
	}
	else
	{
		if(index>=m_data2.GetSize())
			average = -1;
		else
			average = (1.0/m_percent)*GetVal(m_data2,index);
	}
	return average;
}

