// XcelDetailDataInfo.cpp: implementation of the XcelDetailDataInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VisualTransportationNetwork.h"
#include "XcelDetailDataInfo.h"
#include "XcelDetailData.h"

#define MAX_VAL 1000

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

XcelDetailDataInfo::XcelDetailDataInfo()
{

}

XcelDetailDataInfo::~XcelDetailDataInfo()
{

}

void XcelDetailDataInfo::Execute(CString folderName,double percent)
{
	XcelDetailData *pData1,*pData2,*pData3,*pData4;
	double min=10000,max=0;
	pData1 = new XcelDetailData(folderName,0,percent);
	pData2 = new XcelDetailData(folderName,1,percent);
	pData3 = new XcelDetailData(folderName,2,percent);
	pData4 = new XcelDetailData(folderName,3,percent);
	pData1->ReadData(min,max);
	pData2->ReadData(min,max);
	pData3->ReadData(min,max);
	pData4->ReadData(min,max);
	m_max = max;
	m_regular.Add(pData1);
	m_gossip.Add(pData2);
	m_public.Add(pData3);
	m_realPublic.Add(pData4);
}

void XcelDetailDataInfo::Average()
{
	m_regular.Average(m_max);
	m_gossip.Average(m_max);
	m_public.Average(m_max);
	m_realPublic.Average(m_max);
}

void XcelDetailDataInfo::SpecialAverage()
{
	m_regular.SpecialAverage(m_max);
	m_gossip.SpecialAverage(m_max);
	m_public.SpecialAverage(m_max);
	m_realPublic.SpecialAverage(m_max);
}




void XcelDetailDataInfo::WriteAverage(CString folderName)
{
	::CreateDirectory(folderName,NULL);
	CString str;
	CStdioFile outputFile;
	outputFile.Open(folderName+"/pathTimeGraph.txt",CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	int val1,val2,val3,val4;
	for(int i=0;i<m_max;i++)
	{
		val1 = GetVal(m_regular.m_averageList,i);
		val2 = GetVal(m_gossip.m_averageList,i);
		val3 = GetVal(m_public.m_averageList,i);
		val4 = GetVal(m_realPublic.m_averageList,i);
//		str.Format("%d %d %d %d\n",val1,val2,val3,val4);
		str.Format("%d %d %d %d\n",min(MAX_VAL,val1),min(MAX_VAL,val2),min(MAX_VAL,val3),min(MAX_VAL,val4));
		outputFile.WriteString(str);
	}
}

void XcelDetailDataInfo::WriteSpecialAverage(CString folderName,bool limit)
{

	CStdioFile file;
	file.Open(folderName+"/test.txt",CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	XcelDetailData* pData;
	CString s;
	for(int k=0;k<m_regular.m_dataList.GetSize();k++)
	{
		pData = (XcelDetailData*)m_regular.m_dataList.GetAt(k);
		s.Format("%d\n",(int)pData->GetSpecialValue(3));
		file.WriteString(s);
	}


	::CreateDirectory(folderName,NULL);
	CString str;
	CStdioFile outputFile;
	if(limit)
		outputFile.Open(folderName+"/specialPathTimeGraphLimit.txt",CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	else
		outputFile.Open(folderName+"/specialPathTimeGraph.txt",CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	int val1,val2,val3,val4;
	for(int i=0;i<m_max;i++)
	{
		val1 = GetVal(m_regular.m_specialAverageList,i);
		val2 = GetVal(m_gossip.m_specialAverageList,i);
		val3 = GetVal(m_public.m_specialAverageList,i);
		val4 = GetVal(m_realPublic.m_specialAverageList,i);
//		str.Format("%d %d %d %d\n",val1,val2,val3,val4);
		if(limit)
			str.Format("%d %d %d %d\n",min(MAX_VAL,val1),min(MAX_VAL,val2),min(MAX_VAL,val3),min(MAX_VAL,val4));
		else
			str.Format("%d %d %d %d\n",val1,val2,val3,val4);
		outputFile.WriteString(str);
	}
}
