// XcelGossipData.cpp: implementation of the XcelGossipData class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VisualTransportationNetwork.h"
#include "XcelGossipData.h"
#include "TBUAvg.h"
#include "EIDAvg.h"
#include "LearningProbAvg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

XcelGossipData::XcelGossipData()
{
	m_fileCount = 0;
	m_totalLineCount = 0;
	m_roadCount = 0;
	m_loadTrueData.SetSize(70);
	m_loadFalseData.SetSize(70);
	m_loadNumTrueData.SetSize(70);
	m_loadNumFalseData.SetSize(70);
	for(int i=0;i<m_loadTrueData.GetSize();i++)
	{
		SetVal(m_loadTrueData,i,0);
		SetVal(m_loadFalseData,i,0);
		SetVal(m_loadNumTrueData,i,0);
		SetVal(m_loadNumFalseData,i,0);
	}
	m_distDataTrueData.SetSize(43);
	m_distDataFalseData.SetSize(43);
	m_distNum.SetSize(43);
	m_distEIURDataTrueData.SetSize(43);
	m_distEIURDataFalseData.SetSize(43);
	for(i=0;i<m_distNum.GetSize();i++)
	{
		SetVal(m_distDataTrueData,i,0);
		SetVal(m_distDataFalseData,i,0);
		SetVal(m_distEIURDataTrueData,i,0);
		SetVal(m_distEIURDataFalseData,i,0);
		SetVal(m_distNum,i,0);
	}
}

XcelGossipData::~XcelGossipData()
{

}


void XcelGossipData::ReadAgain(CString folderName) 
{
	CString line,startLine="GossipInfo ([edge-id] [from-edge-id] (dist): [sim-len / update times] [TrueData] [sim-len / update times] [FalseData] [avg delay / update times] [TrueData] [avg delay / update times] [FalseData])"; //raz added ()
	CStdioFile file;
	CString fileName = "/gossip_gossip.txt";
	file.Open(folderName+fileName,CFile::modeReadWrite | CFile::shareDenyNone);
	while(file.ReadString(line))
	{
		if(line==startLine)
			break;
	}
	GossipDataInfo *pVal,*pFromVal;
	int index,val;
	int source,dest,timeTrueData,timeFalseData;
	CString strTemp;
	while(file.ReadString(line) && line!="")
	{
		source = atof(CentralInfo::GetToken(line,0,' '));
		dest = atof(CentralInfo::GetNextToken(line,' ',true));
		CentralInfo::GetNextToken(line,' ',true);

		// sim length / # of updates = TBU (for true data)
		timeTrueData = atof(CentralInfo::GetNextToken(line,' ',true));

		strTemp = CentralInfo::GetNextToken(line,' ',true); //[T]

		// sim length / # of updates = TBU (for false data)
		timeFalseData = atof(CentralInfo::GetNextToken(line,' ',true));


		pVal = NULL;
		pFromVal = NULL; //15-04-06 raz
		
		if (timeTrueData != -1)
		{
			pVal = NULL;
			pFromVal = NULL; //15-04-06 raz
			m_dataTrueData.Lookup(source,(void*&)pVal);
			m_fromTrueData.Lookup(dest,(void*&)pFromVal);
			index = (pVal->load+pFromVal->load)/(2*200);
			val = GetVal(m_loadNumTrueData,index);
			SetVal(m_loadNumTrueData,index,++val);
			val = GetVal(m_loadTrueData,index);
			SetVal(m_loadTrueData,index,val+timeTrueData);
		}
		if (timeFalseData != -1)
		{
			pVal = NULL;
			pFromVal = NULL; //15-04-06 raz
			m_dataFalseData.Lookup(source,(void*&)pVal);
			m_fromFalseData.Lookup(dest,(void*&)pFromVal);
			index = (pVal->load+pFromVal->load)/(2*200);
			val = GetVal(m_loadNumFalseData,index);
			SetVal(m_loadNumFalseData,index,++val);
			val = GetVal(m_loadFalseData,index);
			SetVal(m_loadFalseData,index,val+timeFalseData);
		}
	}
}

void XcelGossipData::LoadMatrixDist(CString path)
{
	CStdioFile file;
	int source,dest,dist;
	CString line,str;
	int max=0;
	file.Open(path,CFile::modeReadWrite | CFile::shareDenyNone);
	while(file.ReadString(line))
	{
		source = atof(CentralInfo::GetToken(line,0,' '));
		dest = atof(CentralInfo::GetNextToken(line,' ',true));
		dist = atof(CentralInfo::GetNextToken(line,' ',true));
		if(dist>max)
			max=dist;
		str.Format("%d %d",source,dest);
		m_distMatrix.SetAt(str,new int(dist));
	}

}

int XcelGossipData::GetDist(int source, int dest)
{
	CString str;
	int* dist;
	str.Format("%d %d",source,dest);
	m_distMatrix.Lookup(str,(void*&)dist);
	return *dist;
}

void XcelGossipData::ReadData(CString folderName) 
{
	CString line,startLine="GossipInfo ([edge-id] [from-edge-id] (dist): [sim-len / update times] [TrueData] [sim-len / update times] [FalseData] [avg delay / update times] [TrueData] [avg delay / update times] [FalseData])"; //raz added ()
	CStdioFile file;
	CString fileName = "/gossip_gossip.txt";
	file.Open(folderName+fileName,CFile::modeReadWrite | CFile::shareDenyNone);
	while(file.ReadString(line))
	{
		if(line==startLine)
			break;
	}
	GossipDataInfo *pVal,*pFromVal;
	int* pTimeVal;
	TBUAvg *pDistanceTBUVal;
	EIDAvg *pDistanceEIDVal;

	int source,dest,timeTrueData,timeFalseData,delayTrueData, delayFalseData,distance,val;
	m_fileCount++;
	int lineCount=0;
	CString strDist, strTemp;
	while(file.ReadString(line) && line!="")
	{
		lineCount++;
		//edge id =
		source = atof(CentralInfo::GetToken(line,0,' '));
		//from edge id =
		dest = atof(CentralInfo::GetNextToken(line,' ',true));
		// distance =
		strDist = CentralInfo::GetNextToken(line,' ',true);
		// sim length / # of updates = TBU (for true data)
		timeTrueData = atof(CentralInfo::GetNextToken(line,' ',true));

		strTemp = CentralInfo::GetNextToken(line,' ',true); //[T]

		// sim length / # of updates = TBU (for false data)
		timeFalseData = atof(CentralInfo::GetNextToken(line,' ',true));

		strTemp = CentralInfo::GetNextToken(line,' ',true); //[F]
		
		// avg delay / update time = EID = (for true data)
		delayTrueData = atof(CentralInfo::GetNextToken(line,' ',true));

		strTemp = CentralInfo::GetNextToken(line,' ',true); //[T]

		// avg delay / update time = EID = (for false data)
		delayFalseData = atof(CentralInfo::GetNextToken(line,' ',true));

		strTemp = CentralInfo::GetNextToken(line,' ',true); //[F]

		//		distance = atoi((LPCSTR)strDist.Mid(1,strDist.GetLength()-2));
		distance = GetDist(source,dest);

		//m_distNum counts the number of TBUS with the same distance
		val = GetVal(m_distNum,distance);
		SetVal(m_distNum,distance,++val);

		if (timeTrueData != -1) // if it's -1 it "does not exist"
		{
			val = GetVal(m_distDataTrueData,distance);
			SetVal(m_distDataTrueData,distance,val+delayTrueData);
			val = GetVal(m_distEIURDataTrueData,distance);
			SetVal(m_distEIURDataTrueData,distance,val+timeTrueData);

			//RAZ 17-2-05
			// save the number of edges per TBU

			pTimeVal = NULL;
			m_timeTrueData.Lookup(timeTrueData,(void*&)pTimeVal);
			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_timeTrueData.SetAt(timeTrueData,pTimeVal);

			//RAZ 17-2-05
			//save the number of TBU per distance
			pDistanceTBUVal = NULL;

			m_DistanceTBUTrueData.Lookup(distance,(void*&)pDistanceTBUVal);
			if(pDistanceTBUVal==NULL)
				pDistanceTBUVal = new TBUAvg(timeTrueData, 1);
			else
			{
				pDistanceTBUVal->avg = ((float)timeTrueData + (pDistanceTBUVal->avg *pDistanceTBUVal->count)) / (float)(pDistanceTBUVal->count + 1);
				pDistanceTBUVal->count++;
			}
			m_DistanceTBUTrueData.SetAt(distance,pDistanceTBUVal);

		
			//RAZ 17-2-05
			//save the number of EID per distance
			pDistanceEIDVal = NULL;

			m_DistanceEIDTrueData.Lookup(distance,(void*&)pDistanceEIDVal);
			if(pDistanceEIDVal==NULL)
				pDistanceEIDVal = new EIDAvg(delayTrueData, 1);
			else
			{
				pDistanceEIDVal->avg = ((float)delayTrueData + (pDistanceEIDVal->avg *pDistanceEIDVal->count)) / (float)(pDistanceEIDVal->count + 1);
				pDistanceEIDVal->count++;
			}
			m_DistanceEIDTrueData.SetAt(distance,pDistanceEIDVal);

			pVal = NULL;
			pFromVal = NULL;

			
			m_dataTrueData.Lookup(source,(void*&)pVal);
			m_fromTrueData.Lookup(dest,(void*&)pFromVal);
			if(pVal==NULL)
			{
				pVal = new GossipDataInfo();
				pVal->time = timeTrueData;
				pVal->delay = delayTrueData;
				pVal->count++;
			}
			else
			{
				pVal->time += timeTrueData;
				pVal->delay += delayTrueData;
				pVal->count++;
			}
			m_dataTrueData.SetAt(source,pVal);

			if(pFromVal==NULL)
			{
				pFromVal = new GossipDataInfo();
				pFromVal->time = timeTrueData;
				pFromVal->delay = delayTrueData;
				pFromVal->count++;
			}
			else
			{
				pFromVal->time += timeTrueData;
				pFromVal->delay += delayTrueData;
				pFromVal->count++;
			}
			m_fromTrueData.SetAt(dest,pFromVal);

		}
		
		if (timeFalseData != -1) // if it's -1 it "does not exist"
		{
			val = GetVal(m_distDataFalseData,distance);
			SetVal(m_distDataFalseData,distance,val+delayFalseData);
			val = GetVal(m_distEIURDataFalseData,distance);
			SetVal(m_distEIURDataFalseData,distance,val+timeFalseData);

			//RAZ 17-2-05
			// save the number of edges per TBU
			pTimeVal = NULL;
			m_timeFalseData.Lookup(timeFalseData,(void*&)pTimeVal);
			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_timeFalseData.SetAt(timeFalseData,pTimeVal);

			//RAZ 17-2-05
			//save the number of TBU per distance

			pDistanceTBUVal = NULL;

			m_DistanceTBUFalseData.Lookup(distance,(void*&)pDistanceTBUVal);
			if(pDistanceTBUVal==NULL)
				pDistanceTBUVal = new TBUAvg(timeFalseData, 1);
			else
			{
				pDistanceTBUVal->avg = ((float)timeFalseData + (pDistanceTBUVal->avg *pDistanceTBUVal->count)) / (float)(pDistanceTBUVal->count + 1);
				pDistanceTBUVal->count++;
			}
			m_DistanceTBUFalseData.SetAt(distance,pDistanceTBUVal);
		
			//RAZ 17-2-05
			//save the number of EID per distance
			pDistanceEIDVal = NULL;

			m_DistanceEIDFalseData.Lookup(distance,(void*&)pDistanceEIDVal);
			if(pDistanceEIDVal==NULL)
				pDistanceEIDVal = new EIDAvg(delayFalseData, 1);
			else
			{
				pDistanceEIDVal->avg = ((float)delayFalseData + (pDistanceEIDVal->avg *pDistanceEIDVal->count)) / (float)(pDistanceEIDVal->count + 1);
				pDistanceEIDVal->count++;
			}
			m_DistanceEIDFalseData.SetAt(distance,pDistanceEIDVal);

			pVal = NULL;
			pFromVal = NULL;

			m_dataFalseData.Lookup(source,(void*&)pVal);
			m_fromFalseData.Lookup(dest,(void*&)pFromVal);
			if(pVal==NULL)
			{
				pVal = new GossipDataInfo();
				pVal->time = timeFalseData;
				pVal->delay = delayFalseData;
				pVal->count++;
			}
			else
			{
				pVal->time += timeFalseData;
				pVal->delay += delayFalseData;
				pVal->count++;
			}
			m_dataFalseData.SetAt(source,pVal);

			if(pFromVal==NULL)
			{
				pFromVal = new GossipDataInfo();
				pFromVal->time = timeFalseData;
				pFromVal->delay = delayFalseData;
				pFromVal->count++;
			}
			else
			{
				pFromVal->time += timeFalseData;
				pFromVal->delay += delayFalseData;
				pFromVal->count++;
			}
			m_fromFalseData.SetAt(dest,pFromVal);		
		}
	}

	startLine="TrafficLoadInfo";
	while(file.ReadString(line) && line!="")
	{
		if(line==startLine)
			break;
	}
	int roadCount=0;
	while(file.ReadString(line) && line!="")
	{
		roadCount++;
		source = atof(CentralInfo::GetToken(line,0,' '));
		dest = atof(CentralInfo::GetNextToken(line,' ',true));
		
		pVal = NULL;
		pFromVal = NULL;

		m_dataTrueData.Lookup(source,(void*&)pVal);
		m_fromTrueData.Lookup(source,(void*&)pFromVal);
		if(pVal!=NULL)
		{
			pVal->load = dest;
			m_dataTrueData.SetAt(source,pVal);
		}
		if(pFromVal!=NULL)
		{
			pFromVal->load = dest;
			m_fromTrueData.SetAt(source,pFromVal);
		}

		pVal = NULL;
		pFromVal = NULL;

		m_dataFalseData.Lookup(source,(void*&)pVal);
		m_fromFalseData.Lookup(source,(void*&)pFromVal);
		if(pVal!=NULL)
		{
			pVal->load = dest;
			m_dataFalseData.SetAt(source,pVal);
		}
		if(pFromVal!=NULL)
		{
			pFromVal->load = dest;
			m_fromFalseData.SetAt(source,pFromVal);
		}

	}

	m_roadCount = roadCount;

	m_totalLineCount+=lineCount;
	ReadAgain(folderName);
}

void XcelGossipData::ReadLearningProbabilityData(CString folderName) 
{
	CString line,temp,startLine="Update road [num]: [update count] [not update count] [count]";
	CStdioFile file;
	CString fileName = "/gossip_gossipLearningProb.txt";
	file.Open(folderName+fileName,CFile::modeReadWrite | CFile::shareDenyNone);
	while(file.ReadString(line))
	{
		if(line==startLine)
			break;
	}

	int roadId;
	float updateCountTrueData, updateCountFalseData, 
		notUpdateCountTrueData, notUpdateCountFalseData, 
		probabilityTrueData, probabilityFalseData;
	LearningProbAvg *pLearningProbVal;

	while(file.ReadString(line) && line!="")
	{
		if (line.Find("Total Update") >= 0)
			continue;

		//update road str=
		temp = CentralInfo::GetToken(line,0,' ');
		//update road str=
		temp = CentralInfo::GetNextToken(line,' ',true);
		//road id =
		roadId = atoi(CentralInfo::GetNextToken(line,' ',true));
		// update count = (true data)
		updateCountTrueData = atof(CentralInfo::GetNextToken(line,' ',true));
		//[T]
		temp = CentralInfo::GetNextToken(line,' ',true);
		// update count = (false data)
		updateCountFalseData = atof(CentralInfo::GetNextToken(line,' ',true));
		//[F]
		temp = CentralInfo::GetNextToken(line,' ',true);


		// not update count = (true data)
		notUpdateCountTrueData = atof(CentralInfo::GetNextToken(line,' ',true));
		//[T]
		temp = CentralInfo::GetNextToken(line,' ',true);
		// update count = (false data)
		notUpdateCountFalseData = atof(CentralInfo::GetNextToken(line,' ',true));

		//RAZ 17-2-05
		// save the learning probability per edge
		if (updateCountTrueData == 0 && notUpdateCountTrueData == 0)
			probabilityTrueData = 0;
		else
			probabilityTrueData = (float)updateCountTrueData / (float)((float)updateCountTrueData + (float)notUpdateCountTrueData);

		if (updateCountFalseData == 0 && notUpdateCountFalseData == 0)
			probabilityFalseData = 0;
		else
			probabilityFalseData = (float)updateCountFalseData / (float)((float)updateCountFalseData + (float)notUpdateCountFalseData);

		pLearningProbVal = NULL;
		m_LearningProbabilityTrueData.Lookup(roadId,(void*&)pLearningProbVal);
		if(pLearningProbVal==NULL)
			pLearningProbVal = new LearningProbAvg(probabilityTrueData, 1);
		else
		{
			pLearningProbVal->avg = ((float)probabilityTrueData + (pLearningProbVal->avg *pLearningProbVal->count)) / (float)(pLearningProbVal->count + 1);
			pLearningProbVal->count++;
		}
		m_LearningProbabilityTrueData.SetAt(roadId,pLearningProbVal);

		pLearningProbVal = NULL;
		m_LearningProbabilityFalseData.Lookup(roadId,(void*&)pLearningProbVal);
		if(pLearningProbVal==NULL)
			pLearningProbVal = new LearningProbAvg(probabilityFalseData, 1);
		else
		{
			pLearningProbVal->avg = ((float)probabilityFalseData + (pLearningProbVal->avg *pLearningProbVal->count)) / (float)(pLearningProbVal->count + 1);
			pLearningProbVal->count++;
		}
		m_LearningProbabilityFalseData.SetAt(roadId,pLearningProbVal);
	
	}

	// calculate the accumulated data now
	// for true data
	int *pTimeVal = NULL;
		
	POSITION pos = m_LearningProbabilityTrueData.GetStartPosition();
	WORD key;
	pLearningProbVal = NULL;
	int probabilityGroup = -1;

	while(pos)
	{
		pTimeVal = NULL;
		m_LearningProbabilityTrueData.GetNextAssoc(pos,key,(void*&)pLearningProbVal);
		if (pLearningProbVal->avg < (float)0.1)
		{
			probabilityGroup = 1;
			m_LearningProbabilityAccTrueData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccTrueData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.2)
		{
			probabilityGroup = 2;
			m_LearningProbabilityAccTrueData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccTrueData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.3)
		{
			probabilityGroup = 3;
			m_LearningProbabilityAccTrueData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccTrueData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.4)
		{
			probabilityGroup = 4;
			m_LearningProbabilityAccTrueData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccTrueData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.5)
		{
			probabilityGroup = 5;
			m_LearningProbabilityAccTrueData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccTrueData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.6)
		{
			probabilityGroup = 6;
			m_LearningProbabilityAccTrueData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccTrueData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.7)
		{
			probabilityGroup = 7;
			m_LearningProbabilityAccTrueData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccTrueData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.8)
		{
			probabilityGroup = 8;
			m_LearningProbabilityAccTrueData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccTrueData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.9)
		{
			probabilityGroup = 9;
			m_LearningProbabilityAccTrueData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccTrueData.SetAt(probabilityGroup,pTimeVal);
		}
		else
		{
			probabilityGroup = 10;
			m_LearningProbabilityAccTrueData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccTrueData.SetAt(probabilityGroup,pTimeVal);
		}
	}	

	//for false data
	pTimeVal = NULL;
		
	pos = m_LearningProbabilityFalseData.GetStartPosition();
	pLearningProbVal = NULL;
	probabilityGroup = -1;

	while(pos)
	{
		pTimeVal = NULL;
		m_LearningProbabilityFalseData.GetNextAssoc(pos,key,(void*&)pLearningProbVal);
		if (pLearningProbVal->avg < (float)0.1)
		{
			probabilityGroup = 1;
			m_LearningProbabilityAccFalseData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccFalseData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.2)
		{
			probabilityGroup = 2;
			m_LearningProbabilityAccFalseData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccFalseData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.3)
		{
			probabilityGroup = 3;
			m_LearningProbabilityAccFalseData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccFalseData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.4)
		{
			probabilityGroup = 4;
			m_LearningProbabilityAccFalseData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccFalseData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.5)
		{
			probabilityGroup = 5;
			m_LearningProbabilityAccFalseData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccFalseData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.6)
		{
			probabilityGroup = 6;
			m_LearningProbabilityAccFalseData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccFalseData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.7)
		{
			probabilityGroup = 7;
			m_LearningProbabilityAccFalseData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccFalseData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.8)
		{
			probabilityGroup = 8;
			m_LearningProbabilityAccFalseData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccFalseData.SetAt(probabilityGroup,pTimeVal);
		}
		else if (pLearningProbVal->avg < (float)0.9)
		{
			probabilityGroup = 9;
			m_LearningProbabilityAccFalseData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccFalseData.SetAt(probabilityGroup,pTimeVal);
		}
		else
		{
			probabilityGroup = 10;
			m_LearningProbabilityAccFalseData.Lookup(probabilityGroup,(void*&)pTimeVal);

			if(pTimeVal==NULL)
				pTimeVal = new int(0);
			*pTimeVal = *pTimeVal+1;
			m_LearningProbabilityAccFalseData.SetAt(probabilityGroup,pTimeVal);
		}
	}	
}


void XcelGossipData::Write(CString folderName)
{
	CString str;
	CStdioFile outputFile;
	::CreateDirectory(folderName,NULL);
	Write(folderName+"/toGossipTrueData.txt",&m_dataTrueData);
	Write(folderName+"/toGossipFalseData.txt",&m_dataFalseData);
	Write(folderName+"/fromGossipTrueData.txt",&m_fromTrueData);
	Write(folderName+"/fromGossipFalseData.txt",&m_fromFalseData);
	WriteTime(folderName+"/GossipTimeTrueData.txt",&m_timeTrueData);
	WriteTime(folderName+"/GossipTimeFalseData.txt",&m_timeFalseData);
	WriteLoad(folderName+"/GossipLoadTrueData.txt", true);
	WriteLoad(folderName+"/GossipLoadFalseData.txt", false);
	WriteEIURDist(folderName+"/GossipDistEIURTrueData.txt",m_distEIURDataTrueData);
	WriteEIURDist(folderName+"/GossipDistEIURFalseData.txt",m_distEIURDataFalseData);
	WriteDist(folderName+"/GossipDistTrueData.txt",m_distDataTrueData);
	WriteDist(folderName+"/GossipDistFalseData.txt",m_distDataFalseData);
}

void XcelGossipData::Write(CString fileName,CMapWordToPtr* pData)
{
	CString str;
	CStdioFile outputFile;
	outputFile.Open(fileName,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	POSITION pos = pData->GetStartPosition();//RAZ: changed from m_data to pData
	WORD key;
	GossipDataInfo* pVal;
	GossipDataInfo* p;
	CWordArray array;
	while(pos)
	{
		pData->GetNextAssoc(pos,key,(void*&)pVal);
		for(int i=0;i<array.GetSize();i++)
		{
			pData->Lookup(array.GetAt(i),(void*&)p);
			if(p->time/p->count> pVal->time/pVal->count)
				break;
		}
		array.InsertAt(i,key);
	}
	for(int i=0;i<array.GetSize();i++)
	{
		pData->Lookup(array.GetAt(i),(void*&)p);
		if(p->time>0)
		{
			str.Format("%d %d\n",array.GetAt(i),p->time/p->count);
			outputFile.WriteString(str);
		}
	}

}

void XcelGossipData::WriteTime(CString fileName,CMapWordToPtr* pData)
{
	CString str;
	CStdioFile outputFile;
	outputFile.Open(fileName,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	POSITION pos = pData->GetStartPosition();//RAZ changed from m_data to pData
	WORD key;
	int* pVal;
	CPtrArray array;
	array.SetSize(501);
	for(int i=0;i<array.GetSize();i++)
	{
		SetVal(array,i,0);
	}
	while(pos)
	{
		pData->GetNextAssoc(pos,key,(void*&)pVal);
		SetVal(array,key,*pVal);
	}
	int count = m_fileCount*m_roadCount*m_roadCount;
	for(i=0;i<array.GetSize();i++)
	{
		int num = GetVal(array,i);
		str.Format("%0.3f\n",GetVal(array,i)/((double)m_fileCount*m_roadCount*m_roadCount));
		outputFile.WriteString(str);
	}

}

//RAZ 17-2-06
// Write the Accumulated TBU values to file
void XcelGossipData::WriteRazAccTBU(CString fileName,CMapWordToPtr* pData)
{
	CString str;
	CStdioFile outputFile;
	outputFile.Open(fileName,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	POSITION pos = pData->GetStartPosition();
	WORD key;
	int* pVal;
	CPtrArray array;
	array.SetSize(501);
	for(int i=0;i<array.GetSize();i++)
	{
		SetVal(array,i,0);
	}
	while(pos)
	{
		pData->GetNextAssoc(pos,key,(void*&)pVal);
		SetVal(array,key,*pVal);
	}
	int total_edges_number = 0;
	int edges_number = 0;
	for(i=0;i<array.GetSize();i++)
	{
		edges_number = GetVal(array,i);
		total_edges_number += edges_number;
	}

	//write header
	str.Format("Accumulated Edges\tTBU\n");
	outputFile.WriteString(str);


	float total_accumulated_edges = 0;
	for(i=0;i<array.GetSize();i++)
	{
		edges_number = GetVal(array,i);
		float accumulated_edges = (float)edges_number / (float)total_edges_number;
		total_accumulated_edges += accumulated_edges;

		str.Format("%0.3f\t%d\n", total_accumulated_edges,i);
		outputFile.WriteString(str);
	}
}

//RAZ 17-2-06
// Write the TBU as function od Distance values to file
void XcelGossipData::WriteRazTBUDistance(CString fileName,CMapWordToPtr* pData)
{
	CString str;
	CStdioFile outputFile;
	outputFile.Open(fileName,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	POSITION pos = pData->GetStartPosition();
	WORD key;
	TBUAvg* pVal;
	CPtrArray array;
	array.SetSize(501);
	for(int i=0;i<array.GetSize();i++)
	{
		SetVal(array,i,0);
	}
	while(pos)
	{
		pData->GetNextAssoc(pos,key,(void*&)pVal);
		SetVal(array,key,pVal->avg);
	}


	//write header
	str.Format("TBU\tDistance\n");
	outputFile.WriteString(str);

	for(i=0;i<array.GetSize();i++)
	{
		float TBU = GetVal(array,i);

		str.Format("%0.3f\t%d\n", TBU,i);
		outputFile.WriteString(str);
	}
}

//RAZ 14-04-06
// Write the learning probabilities as a function of the accumulated edges
void XcelGossipData::WriteRazLearningProbability(CString fileName,CMapWordToPtr* pData)
{
	// need to calculate accumulated data
	// now the data is in the map like this:
	// [probability-group] [count]
	CString str;
	CStdioFile outputFile;
	outputFile.Open(fileName,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	POSITION pos = pData->GetStartPosition();
	WORD key;
	int* pVal;
	CPtrArray array;
	array.SetSize(501);
	for(int i=0;i<array.GetSize();i++)
	{
		SetVal(array,i,0);
	}
	while(pos)
	{
		pData->GetNextAssoc(pos,key,(void*&)pVal);
		SetVal(array,key,*pVal);
	}
	int total_edges_number = 0;
	int edges_number = 0;
	for(i=0;i<array.GetSize();i++)
	{
		edges_number = GetVal(array,i);
		total_edges_number += edges_number;
	}

	//write header
	str.Format("Accumulated Edges\tLearning Probability\n");
	outputFile.WriteString(str);


	float total_accumulated_edges = 0;
	for(i= array.GetSize()-1; i >= 0;i--)
	{
		edges_number = GetVal(array,i);
		float accumulated_edges = (float)edges_number / (float)total_edges_number;
		total_accumulated_edges += accumulated_edges;

		str.Format("%0.3f\t%d\n", total_accumulated_edges,i);
		outputFile.WriteString(str);
	}
}

//RAZ 17-2-06
// Write the EID as a function of distance values to file
void XcelGossipData::WriteRazEIDDistance(CString fileName,CMapWordToPtr* pData)
{
	CString str;
	CStdioFile outputFile;
	outputFile.Open(fileName,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	POSITION pos = pData->GetStartPosition();
	WORD key;
	EIDAvg* pVal;
	CPtrArray array;
	array.SetSize(501);
	for(int i=0;i<array.GetSize();i++)
	{
		SetVal(array,i,0);
	}
	while(pos)
	{
		pData->GetNextAssoc(pos,key,(void*&)pVal);
		SetVal(array,key,pVal->avg);
	}


	//write header
	str.Format("EID\tDistance\n");
	outputFile.WriteString(str);

	for(i=0;i<array.GetSize();i++)
	{
		float EID = GetVal(array,i);

		str.Format("%0.3f\t%d\n", EID,i);
		outputFile.WriteString(str);
	}
}

void XcelGossipData::WriteLoad(CString fileName, bool isTrueData)
{
	CString str;
	CStdioFile outputFile;
	outputFile.Open(fileName,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	//POSITION pos = m_data.GetStartPosition();
	//WORD key;
	//int* pVal;
	if (isTrueData)
	{
		for(int i=0;i<m_loadNumTrueData.GetSize();i++)
		{
			if(GetVal(m_loadNumTrueData,i)>0)
			{
				str.Format("%d %d\n",(i*200)+100,(int)GetVal(m_loadTrueData,i)/(int)GetVal(m_loadNumTrueData,i));
				outputFile.WriteString(str);
			}
		}
	}
	else
	{
		for(int i=0;i<m_loadNumFalseData.GetSize();i++)
		{
			if(GetVal(m_loadNumFalseData,i)>0)
			{
				str.Format("%d %d\n",(i*200)+100,(int)GetVal(m_loadFalseData,i)/(int)GetVal(m_loadNumFalseData,i));
				outputFile.WriteString(str);
			}
		}
	}
}

void XcelGossipData::WriteDist(CString fileName, CPtrArray& array)
{
	CString str;
	CStdioFile outputFile;
	outputFile.Open(fileName,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	//WORD key;
	//int* pVal;
	int sum=0,count=0,total; 
	for(int i=1;i<m_distNum.GetSize();i++)
	{
		if(GetVal(m_distNum,i)>0)
		{
			count++;
			int dd = GetVal(array,i);
			int fff = GetVal(m_distNum,i);
			sum+= GetVal(array,i)/GetVal(m_distNum,i);
		}
		
		if(i%4==0)
		{
			total=0;
			if(count>0)
				total = sum/count;
			str.Format("%d %d\n",i-4,total);
			outputFile.WriteString(str);
			sum=0;
			count=0;
		}

	}

}

void XcelGossipData::WriteEIURDist(CString fileName, CPtrArray& array)
{
	CString str;
	CStdioFile outputFile;
	outputFile.Open(fileName,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyNone);
	//WORD key;
//	int* pVal;
	int sum=0,count=0,total; 
	for(int i=1;i<m_distNum.GetSize();i++)
	{
		if(GetVal(m_distNum,i)>0)
		{
			count++;
			int dd = GetVal(array,i);
			int fff = GetVal(m_distNum,i);
			sum+= GetVal(array,i)/GetVal(m_distNum,i);
		}
		
		if(i%4==0)
		{
			total=0;
			if(count>0)
				total = sum/count;
			str.Format("%d %d\n",i-2,total);
			outputFile.WriteString(str);
			sum=0;
			count=0;
		}

	}

}
