// XcelGossipData.h: interface for the XcelGossipData class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XCELGOSSIPDATA_H__0827A013_6A6E_4DE1_922E_012F2AF9A3CD__INCLUDED_)
#define AFX_XCELGOSSIPDATA_H__0827A013_6A6E_4DE1_922E_012F2AF9A3CD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class GossipDataInfo
{
public:
	int time;
	int delay;
	int load;
	int count;

	GossipDataInfo(){count=0;}
};

class XcelGossipData  
{
public:
	int m_fileCount,m_roadCount;
	int m_totalLineCount;
	CString m_fileName,m_folderName;
	CMapWordToPtr m_dataTrueData, m_dataFalseData, m_fromTrueData, m_fromFalseData, m_timeTrueData, m_timeFalseData, 
		m_DistanceTBUTrueData, m_DistanceTBUFalseData, 
		m_DistanceEIDTrueData,m_DistanceEIDFalseData, 
		m_LearningProbabilityTrueData, m_LearningProbabilityFalseData, m_LearningProbabilityAccTrueData, m_LearningProbabilityAccFalseData;
	CMapStringToPtr m_distMatrix;
	CPtrArray m_loadTrueData,m_loadFalseData,m_loadNumTrueData,m_loadNumFalseData;
	CPtrArray m_distDataTrueData, m_distDataFalseData,m_distNum,m_distEIURDataTrueData,m_distEIURDataFalseData;
public:
	void Write(CString folderName);
	void Write(CString fileName,CMapWordToPtr* pData);
	void WriteTime(CString fileName,CMapWordToPtr* pData);
	void WriteRazAccTBU(CString fileName,CMapWordToPtr* pData);
	void WriteRazLearningProbability(CString fileName,CMapWordToPtr* pData);
	void WriteRazTBUDistance(CString fileName,CMapWordToPtr* pData);
	void WriteRazEIDDistance(CString fileName,CMapWordToPtr* pData);
	void WriteLoad(CString fileName, bool isTrueData);
	void WriteDist(CString fileName, CPtrArray& array);
	void WriteEIURDist(CString fileName, CPtrArray& array);
	void LoadMatrixDist(CString path);
	int GetDist(int source, int dest);
	void ReadData(CString folderName);
	void ReadLearningProbabilityData(CString folderName);//14-04-06 raz
	void ReadAgain(CString folderName);
	XcelGossipData();
	virtual ~XcelGossipData();

};

#endif // !defined(AFX_XCELGOSSIPDATA_H__0827A013_6A6E_4DE1_922E_012F2AF9A3CD__INCLUDED_)
